/*
 * edit.c: This is really a mishmash of function and such that deal with IRCII
 * commands (both normal and keybinding commands) 
 *
 * Written By Michael Sandrof
 *
 * Copyright(c) 1990 
 *
 * See the COPYRIGHT file, or do a HELP IRCII COPYRIGHT 
 */


#include "irc.h"

#include <sys/stat.h>

#ifdef ESIX
# include <lan/net_types.h>
#endif

#include "parse.h"
#include "ircterm.h"
#include "server.h"
#include "chelp.h"
#include "edit.h"
#include "crypt.h"
#include "vars.h"
#include "ircaux.h"
#include "lastlog.h"
#include "window.h"
#include "screen.h"
#include "whois.h"
#include "hook.h"
#include "input.h"
#include "ignore.h"
#include "keys.h"
#include "names.h"
#include "alias.h"
#include "history.h"
#include "funny.h"
#include "ctcp.h"
#include "dcc.h"
#include "translat.h"
#include "output.h"
#include "exec.h"
#include "notify.h"
#include "numbers.h"
#include "status.h"
#include "if.h"
#include "help.h"
#include "stack.h"
#include "queue.h"
#include "timer.h"
#include "list.h"
#include "pluto.h"
#include "userlist.h"

#define COMMENT_HACK 

static	int	save_which;
static	int	save_do_all;
	int	in_e_nick = 0;

static	void	oper_password_received _((char *, char *));
static	char	*do_channel _((char *));

int	no_hook_notify = 0;
char	last_sent_msg_body[BIG_BUFFER_SIZE + 1];
 
extern	char	forwardnick[];
extern void 	dcc_glist _((char *));
extern void io _((void));


/* used with /save */
#define	SFLAG_ALIAS	0x0001
#define	SFLAG_BIND	0x0002
#define	SFLAG_ON	0x0004
#define	SFLAG_SET	0x0008
#define	SFLAG_NOTIFY	0x0010
#define	SFLAG_DIGRAPH	0x0020

/* The maximum number of recursive LOAD levels allowed */
#define MAX_LOAD_DEPTH 10

/* recv_nick: the nickname of the last person to send you a privmsg */
	char	*recv_nick = NULL;

/* sent_nick: the nickname of the last person to whom you sent a privmsg */
	char	*sent_nick = NULL;
	char	*sent_body = NULL;

/* Used to keep down the nesting of /LOADs and to determine if we
 * should activate the warning for /ONs if the NOVICE variable is set.
 */
	int	load_depth = 0;


	int	interactive = 0;
	
/* Used to prevent global messaging */
extern	int	in_on_who;

typedef	struct	WaitCmdstru
{
	char	*stuff;
	struct	WaitCmdstru	*next;
}	WaitCmd;

static	WaitCmd	*start_wait_list = NULL,
		*end_wait_list = NULL;

	char	lame_wait_nick[] = "1#LAME";

/* a few advance declarations */
static	void	do_repeat _((char *, char *, char *));
static	void	do_unkey _((char *, char *, char *));
static	void	do_unscrew _((char *, char *, char *));
static	void	do_getout _((char *, char *, char *));
static	void	do_mynames _((char *, char *, char *));
static	void	my_whois _((char *, char *, char *));
static	void	do_4op _((char *, char *, char *));
static	void	do_umode _((char *, char *, char *));
static	void	do_invite _((char *, char *, char *));
static	void	do_forward _((char *, char *, char *));
static	void	do_oops _((char *, char *, char *));
extern	void	do_ig _((char *, char *, char *));
extern	void	do_listshit _((char *, char *, char *));
extern	void	savelists _((char *, char *, char *));
extern	void	mknu _((char *, char *, char *));
extern	void	reconnect_cmd _((char *, char *, char *));
static	void	sendlinecmd _((char *, char *, char *));
static	void	do_send_text _((char *, char *, char *));
static	void	funny_stuff _((char *, char *, char *));
static	void	cd _((char *, char *, char *));
static	void	e_quit _((char *, char *, char *));
static	void	e_wall _((char *, char *, char *));
static	void	send_2comm _((char *, char *, char *));
static	void	send_comm _((char *, char *, char *));
static	void	send_topic _((char *, char *, char *));
static	void	send_kick _((char *, char *, char *));
static	void	send_channel_com _((char *, char *, char *));
static	void	quote _((char *, char *, char *));
static	void	e_privmsg _((char *, char *, char *));
static	void	flush _((char *, char *, char *));
static	void	away _((char *, char *, char *));
static	void	oper _((char *, char *, char *));
static	void	e_channel _((char *, char *, char *));
static	void	who _((char *, char *, char *));
static	void	whois _((char *, char *, char *));
static	void	ison _((char *, char *, char *));
static	void	userhost _((char *, char *, char *));
static	void	info _((char *, char *, char *));
static	void	e_nick _((char *, char *, char *));
static	void	comment _((char *, char *, char *));
static	void	sleepcmd _((char *, char *, char *));
static	void	version1 _((char *, char *, char *));
static	void	ctcp _((char *, char *, char *));
static	void	dcc _((char *, char *, char *));
static	void	deop _((char *, char *, char *));
static	void	my_echo _((char *, char *, char *));
static	void	save_settings _((char *, char *, char *));
static	void	redirect _((char *, char *, char *));
static	void	waitcmd _((char *, char *, char *));
static	void	describe _((char *, char *, char *));
static	void	me _((char *, char *, char *));
static	void	mload _((char *, char *, char *));
static	void	mlist _((char *, char *, char *));
static	void	evalcmd _((char *, char *, char *));
static	void	hook _((char *, char *, char *));
static	void	inputcmd _((char *, char *, char *));
static	void	pingcmd _((char *, char *, char *));
static	void	xtypecmd _((char *, char *, char *));
static	void	beepcmd _((char *, char *, char *));
static	void	abortcmd _((char *, char *, char *));
static	void	really_save _((char *, char *));
static	void	e_debug _((char *, char *, char *));
extern  void    LameKick  _((char *, char *, char *));
extern  void    ChanWallOp _((char *, char *, char *));
extern  void    NewUser _((char *, char *, char *));
extern  void    ReconnectServer _((char *, char *, char *));
extern  void    MegaDeop _((char *, char *, char *));
extern  void    do_flood _((char *, char *, char *));
extern  void    cycle _((char *, char *, char *));
extern  void    bomb _((char *, char *, char *));
extern  void    finger _((char *, char *, char *));
extern  void    multkick _((char *, char *, char *));
extern  void    massdeop _((char *, char *, char *));
extern  void    doop _((char *, char *, char *));
extern  void    dodeop _((char *, char *, char *));
extern  void    massop _((char *, char *, char *));
extern  void    whokill _((char *, char *, char *));
extern  void 	ban _((char *, char *, char *));
extern  void 	kickban _((char *, char *, char *));
extern  void 	massban _((char *, char *, char *));
extern  void 	dokick _((char *, char *, char *));
extern  void 	nslookup _((char *, char *, char *));
extern  void 	masskick _((char *, char *, char *));
extern  void 	do_flood _((char *, char *, char *));
extern  void 	reset _((char *, char *, char *));
extern  void 	users _((char *, char *, char *));
extern	void	my_ignorehost _((char *, char *,char *));
extern	void	my_ignore _((char *, char *,char *));
extern	void	unban _((char *, char *,char *));
extern	void	siteban _((char *, char *,char *));
extern	void	sitekickban _((char *, char *,char *));
extern	void	masskickban _((char *, char *,char *));
extern  void    linklook _((char *, char *, char *));
extern  void    newhost _((char *, char *, char *));
extern  void	do_dump _((char *, char *, char *));
extern  void	do_dirlastnotice _((char *, char *, char *));
extern  void	do_dirlastmsg _((char *, char *, char *));
extern void 	readlog _((char *, char *, char *));
extern void 	remove_log _((char *, char *, char *));
extern void 	add_user _((char *, char *, char *));
extern void	bot _((char *, char *, char *));
extern void	do_uptime _((char *, char *, char *));
extern void	cdcc _((char *, char *, char *));
extern void	extern_write _((char *, char *, char *));
extern void	showuserlist _((char *, char *, char *));
extern void	init_dcc_chat _((char *, char *, char *));
extern void	add_shit _((char *, char *, char *));
extern void	showshitlist _((char *, char *, char *));
extern void	channel_stats _((char *, char *, char *));
void		my_clear _((char *, char *, char *));
static void	push_cmd _((char *, char *, char *));
static void	pop_cmd _((char *, char *, char *));
void		stubcmd _((char *, char *, char *));
static void	unshift_cmd _((char *, char *, char *));
static void	shift_cmd _((char *, char *, char *));
static void	exec_cmd _((char *, char *, char *));
static void	auto_join _((char *, char *, char *));

extern void	addidle _((char *, char *, char *));
extern void	showidle _((char *, char *, char *));
extern void	kickidle _((char *, char *, char *));
extern void	usage _((char *, char *, char *));
extern void	add_env _((char *));
extern void	reload_save _((char *, char *, char *));
extern void	cset_variable _((char *, char *, char *));
extern void	banstat _((char *,char *, char *));
extern void	nwhois _((char *,char *, char *));
extern void	statkgrep	_((char *, char *, char *));
static void	dcc_crash _((char *, char *, char *));

/* IrcCommand: structure for each command in the command table */
typedef	struct
{
	char	*name;					/* what the user types */
	char	*server_func;				/* what gets sent to the server
							 * (if anything) */
	void	(*func) _((char *, char *, char *));	/* function that is the command */
	unsigned	flags;
}	IrcCommand;

static	IrcCommand *find_command _((char *, int *));

AJoinList *ajoin_list = NULL;

#define NONOVICEABBREV 0x0001
#define	NOINTERACTIVE  0x0002
#define	NOSIMPLESCRIPT 0x0004
#define	NOCOMPLEXSCRIPT 0x0008

/*
 * irc_command: all the availble irc commands:  Note that the first entry has
 * a zero length string name and a null server command... this little trick
 * makes "/ blah blah blah" to always be sent to a channel, bypassing queries,
 * etc.  Neato.  This list MUST be sorted.
 */
static	IrcCommand irc_command[] =
{
	{ "",		empty_string,	do_send_text,		NOSIMPLESCRIPT| NOCOMPLEXSCRIPT },
	/*
	 * I really want to remove #, but it will break a lot of scripts.  - mycroft
	 *
	 * I agree - it should be converted to a special character in parse_line.
	 *                                                            - Troy
	 */
	{ "#",		NULL,		comment, 		0 },
	{ "4OP",	NULL,		do_4op,			0 },
	{ ":",		NULL,		comment, 		0 },
        { "ABORT",      NULL,           abortcmd,               0 },
	{ "ADDBOT",	NULL,		bot,			0 },
	{ "ADDFORWARD",	"ADDFORWARD", 	do_forward,		0 },
	{ "ADDIDLE",	"ADDIDLE",	addidle,		0 },
	{ "ADDSHIT",	NULL,		add_shit,		0 },
	{ "ADDUSER",	NULL,		add_user,		0 },
	{ "ADMIN",	"ADMIN",	send_comm, 		0 },
	{ "AJOIN",	NULL,		auto_join,		0 },
	{ "ALIAS",	"0",		alias,			0 },
#ifdef ALLOC_DEBUG
	{ "ALLOC",	NULL,		alloc_cmd,		0 },
#endif
	{ "ASSIGN",	"1",		alias,			0 },
	{ "AWAY",	"AWAY",		away,			0 },
	{ "B",		NULL,		ban,			0 },
	{ "BAN",	NULL,		ban,			0 },
	{ "BANSTAT",	NULL,		banstat,		0 },
	{ "BEEP",	0,		beepcmd,		0 },
	{ "BHELP",	NULL,		chelp,			0 },
	{ "BIND",	NULL,		bindcmd,		0 },
	{ "BK",		NULL,		kickban,		0 },
	{ "BOMB",	NULL,		bomb,			0 },
	{ "BOOT",	NULL,		multkick,		0 },
	{ "BOT",	NULL,		bot,			0 },
	{ "BOTLIST",	"BotList",	bot,			0 },
	{ "BYE",	"QUIT",		e_quit,			NONOVICEABBREV},
	{ "CD",		NULL,		cd,			0 },
	{ "CDCC",	NULL,		cdcc,			0 },
	{ "CHANNEL",	"JOIN",		e_channel,		0 },
	{ "CHANST",	NULL,		channel_stats,		0 },
	{ "CHELP",	NULL,		chelp,			0 },
	{ "CHGAUTOOP",	"CHGAUTOOP",	change_user,		0 },
	{ "CHGCHAN",	"CHGCHAN",	change_user,		0 },
	{ "CHGLEVEL",	"CHGLEVEL",	change_user,		0 },
	{ "CHGPROT",	"CHGPROT",	change_user,		0 },
	{ "CLEAR",	NULL,		my_clear,		0 },
	{ "COMMENT",	NULL,		comment,		0 },
	{ "CONNECT",	"CONNECT",	send_comm,		0 },
	{ "CSET",	"CSET",		cset_variable,		0 },
	{ "CTCC",	NULL,		dcc,			0 },
	{ "CTCP",	NULL,		ctcp,			0 },
	{ "CYCLE",	NULL,		cycle,			0 },
	{ "D",		NULL,		describe,		0 },
	{ "DATE",	"TIME",		send_comm,		0 },
	{ "DBAN",	NULL,		unban,			0 },
	{ "DC",		NULL,		init_dcc_chat,		0 },
	{ "DCC",	NULL,		dcc,			0 },
	{ "DCCCRASH",	NULL,		dcc_crash,		0 },
	{ "DEBUG",	NULL,		e_debug,		0 },
	{ "DEOP",	NULL,		dodeop,			0 },
	{ "DEOPER",	NULL,		deop,			0 },
	{ "DESCRIBE",	NULL,		describe,		0 },
	{ "DF",		"df",		exec_cmd,		0 },
	{ "DIE",	"DIE",		send_comm,		0 },
	{ "DIGRAPH",	NULL,		digraph,		0 },
	{ "DIRLM",	NULL,		do_dirlastmsg,		0 },
	{ "DIRLN",	NULL,		do_dirlastnotice,	0 },
	{ "DISCONNECT",	NULL,		disconnectcmd,		0 },
	{ "DO",		NULL,		docmd,			0 },
	{ "DUMP",	NULL,		flush_aliases,		0 },
	{ "ECHO",	NULL,		my_echo,		0 },
	{ "ENCRYPT",	NULL,		encrypt_cmd,		0 },
	{ "EVAL",	NULL,		evalcmd,		0 },
	{ "EXEC",	NULL,		execcmd,		0 },
	{ "EXIT",	"QUIT",		e_quit,			NONOVICEABBREV},
	{ "FE",		NULL,		foreach_handler,	0 },
	{ "FEC",	NULL,		fec,			0 },
	{ "FINGER",	NULL,		finger,			0 },
	{ "FLOOD",	NULL,		do_flood,		0 },
	{ "FLUSH",	NULL,		flush,			0 },
	{ "FOR",	NULL,		foreach_handler,	0 },
	{ "FOREACH",	NULL,		foreach_handler,	0 },
	{ "FORWARD",	"FORWARD", 	do_forward,		0 },
	{ "FUCK",	"FUCK",		kickban,		0 },
	{ "HASH",	"HASH",		send_comm,		0 },
	{ "HELP",	NULL,		help,			0 },
	{ "HISTORY",	NULL,		history,		0 },
	{ "HMODE",	NULL,		hmode,			0 },
	{ "HOOK",	NULL,		hook,			0 },
	{ "HOST",	"USERHOST",	userhost,		0 },
	{ "I",		"INVITE",	do_invite,		0 },
	{ "IF",		"IF",		ifcmd,			0 },
	{ "IG",		"IG",		do_ig,			0 },
	{ "IGH",	"IGH",		do_ig,			0 },
	{ "IGNORE",	NULL,		ignore,			0 },
	{ "INFO",	"INFO",		info,			0 },
	{ "INPUT",	NULL,		inputcmd,		0 },
	{ "INVITE",	"INVITE",	do_invite,		0 },
	{ "ISON",	"ISON",		ison,			0 },
	{ "JOIN",	"JOIN",		e_channel,		0 },
	{ "K",		NULL,		dokick,			0 },
	{ "KB",		NULL,		kickban,		0 },
	{ "KICK",	"KICK",		send_kick,		0 },
	{ "KICKIDLE",	NULL,		kickidle,		0 },
	{ "KILL",	"KILL",		send_2comm,		0 },
	{ "L",		"PART",		do_getout,		0 },
	{ "LASTLOG",	NULL,		lastlog,		0 },
	{ "LEAVE",	"PART",		send_channel_com,	0 },
	{ "LINKS",	"LINKS",	send_comm,		NONOVICEABBREV},
	{ "LIST",	"LIST",		funny_stuff,		0 },
	{ "LK",		"KICK",		LameKick,		0 },
	{ "LLOOK",	NULL,		linklook,		0 },
	{ "LOAD",	"LOAD",		load,			0 },
	{ "LS",		"ls",		exec_cmd,		0 },
	{ "LUSERS",	"LUSERS",	send_comm,		0 },
	{ "M",		"PRIVMSG",	e_privmsg,		0 },
	{ "MB",		NULL,		massban,		0 },
	{ "MD",		NULL,		massdeop,		0 },
	{ "MDOP",	NULL,		massdeop,		0 },
	{ "ME",		NULL,		me,			0 },
	{ "MESG",	NULL,		extern_write,		0 },
	{ "MK",		NULL,		masskick,		0 },
	{ "MKB",	NULL,		masskickban,		0 },
	{ "MKNU",	NULL,		mknu,			0 },
	{ "MLIST",	NULL,		mlist,			0 },
	{ "MLOAD",	NULL,		mload,			0 },
	{ "MODE",	"MODE",		send_channel_com,	0 },
	{ "MOP",	NULL,		massop,			0 },
	{ "MOTD",	"MOTD",		send_comm,		0 },
	{ "MSG",	"PRIVMSG",	e_privmsg,		0 },
	{ "MUB",	NULL,		unban,			0 },
	{ "MULT",	NULL,		multkick,		0 },
	{ "N",		"NAMES",	do_mynames,		0 },
	{ "NAMES",	"NAMES",	funny_stuff,		0 },
	{ "NEWHOST",	NULL,		newhost,		0 },
	{ "NEWNICK",	NULL,		newnick,		0 },
	{ "NEWUSER",	NULL,		newuser,		0 },
	{ "NICK",	"NICK",		e_nick,			0 },
	{ "NKILL",	NULL,		nkill,			0 },
	{ "NOFORWARD",  "NOFORWARD",	do_forward,		0 },
	{ "NOTE",	"NOTE",		send_comm,		0 },
	{ "NOTICE",	"NOTICE",	e_privmsg,		0 },
	{ "NOTIFY",	NULL,		notify,			0 },
	{ "NSLOOKUP",	NULL,		nslookup,		0 },
	{ "NWHOIS",	NULL,		nwhois,			0 },
	{ "ON",		NULL,		on,			0 },
	{ "OOPS",	NULL,		do_oops,		0 },
	{ "OP",		NULL,		doop,			0 },
	{ "OPER",	"OPER",		oper,			0 },
	{ "OPS",	NULL,		tochanops,		0 },
	{ "PARSEKEY",	NULL,		parsekeycmd,		0 },
	{ "PART",	"PART",		send_channel_com,	0 },
	{ "PING",	NULL, 		pingcmd,		0 },
	{ "POP",	NULL,		pop_cmd,		0 },
	{ "PS",		"ps",		exec_cmd,		0 },
	{ "PUSH",	NULL,		push_cmd,		0 },
	{ "Q",		NULL,		query,			0 },
	{ "QK",		NULL,		dokick,			0 },
	{ "QUERY",	NULL,		query,			0 },
	{ "QUEUE",      NULL,           queuecmd,               0 },
	{ "QUIT",	"QUIT",		e_quit,			NONOVICEABBREV},
	{ "QUOTE",	NULL,		quote,			0 },
	{ "RBIND",	0,		rbindcmd,		0 },
	{ "READLOG",	0,		readlog,		0 },
	{ "RECONNECT",	NULL,		reconnect_cmd,		0 },
	{ "REDIRECT",	NULL,		redirect,		0 },
	{ "REHASH",	"REHASH",	send_comm,		0 },
	{ "RELOAD",	NULL,		reload_save,		0 },
	{ "REMLOG",	NULL,		remove_log,		0 },
	{ "REPEAT", 	NULL, 		do_repeat,		0 },
	{ "REQUEST",	NULL,		ctcp,			0 },
	{ "RESET",	NULL,		reset,			0 },
	{ "RESTART",	"RESTART",	send_comm,		0 },
	{ "RPING",	"RPING",	send_comm,		0 },
	{ "SAVEA",	NULL,		save_settings,		0 },
	{ "SAVEALL",	"SAVEALL",	savelists,		0 },
	{ "SAVELIST",	NULL, 		savelists,		0 },
	{ "SAY",	empty_string,	do_send_text,		0 },
	{ "SB",		NULL,		siteban,		0 },
	{ "SBAN",	NULL,		siteban,		0 },
	{ "SC",		"NAMES",	do_mynames,		0 },
	{ "SEND",	NULL,		do_send_text,		0 },
	{ "SENDLINE",	empty_string,	sendlinecmd,		0 },
	{ "SERVER",	NULL,		server,			0 },
	{ "SET",	NULL,		set_variable,		0 },
	{ "SHIFT",	NULL,		shift_cmd,		0 },
	{ "SHIT",	NULL,		add_shit,		0 },
	{ "SHITLIST",	NULL,		showshitlist,		0 },
	{ "SHOWIDLE",	NULL,		showidle,		0 },
	{ "SHOWSPLIT",	NULL,		linklook,		0 },
	{ "SIGNOFF",	"QUIT",		e_quit,			NONOVICEABBREV},
	{ "SK",		NULL,		sitekickban,		0 },
	{ "SKB",	NULL,		sitekickban,		0 },
	{ "SLEEP",	NULL,		sleepcmd,		0 },
	{ "SQUIT",	"SQUIT",	send_2comm,		0 },
	{ "STACK",	NULL,		stackcmd,		0 },
	{ "STATS",	"STATS",	send_comm,		0 },
	{ "STATSK",	NULL,		statkgrep,		0 },
	{ "STUB",	"STUB",		stubcmd,		0 },
	{ "SUMMON",	"SUMMON",	send_comm,		0 },
	{ "SWITCH",	"SWITCH",	switchcmd,		0 },
	{ "T", 		"TOPIC",	send_topic,		0 },
	{ "TIME",	"TIME",		send_comm,		0 },
	{ "TIMER",	"TIMER",	timercmd,		0 },
	{ "TOPIC",	"TOPIC",	send_topic,		0 },
	{ "TRACE",	"TRACE",	send_comm,		0 },
	{ "TYPE",	NULL,		type,			0 },
	{ "U",		NULL,		users,			0 },
	{ "UB",		NULL,		unban,			0 },
	{ "UMODE",	"MODE",		do_umode,		0 },
	{ "UNAJOIN",	"UNAJOIN",	auto_join,		0 },
	{ "UNBOT",	"UnBot",	bot,			0 },
	{ "UNIDLE",	"UNIDLE",	addidle,		0 },
	{ "UNIG",	"UNIG",		do_ig,			0 },
	{ "UNIGH",	"UNIGH",	do_ig,			0 },
	{ "UNKEY",	NULL,		do_unkey,		0 },
	{ "UNLESS",	"UNLESS",	ifcmd,			0 },
	{ "UNSCREW",	NULL,		do_unscrew,		0 },
	{ "UNSHIFT",	NULL,		unshift_cmd,		0 },
	{ "UNSHIT",	"UnShit",	add_shit,		0 },
	{ "UNTIL",	"UNTIL",	whilecmd,		0 },
	{ "UNUSER",	"UnUser",	add_user,		0 },
	{ "UPING",	"uPING",	ctcp,			0 },
	{ "UPTIME",	NULL,		do_uptime,		0 },
	{ "USAGE",	NULL,		usage,			0 },
	{ "USER",	NULL,		users,			0 },
	{ "USERHOST",	NULL,		userhost,		0 },
	{ "USERLIST",	NULL,		showuserlist,		0 },
	{ "USERS",	"USERS",	send_comm,		0 },
	{ "VERSION",	"VERSION",	version1,		0 },
	{ "VOICE",	"VOICE",	e_privmsg,		0 },
	{ "W",		"WHO",		who,			0 },
	{ "WAIT",	NULL,		waitcmd,		0 },
	{ "WALL",	"WALL",		e_wall,			0 },
	{ "WALLMSG",	NULL,		ChanWallOp,		0 },
	{ "WALLOPS",	"WALLOPS",	e_wall,			0 },
	{ "WHICH",	"WHICH",	load,			0 },
	{ "WHILE",	"WHILE",	whilecmd,		0 },
	{ "WHO",	"WHO",		who,			0 },
	{ "WHOIS",	"WHOIS",	whois,			0 },
	{ "WHOWAS",	"WHOWAS",	whois,			0 },
	{ "WI",		"WHOIS",	whois,			0 },
	{ "WII",	"WHOIS",	my_whois,		0 },
	{ "WINDOW",	NULL,		window,			0 },
	{ "WW",		"WHOWAS",	whois,			0 },
	{ "XECHO",	"XECHO",	my_echo,		0 },
	{ "XTRA",	"XTRA",		e_privmsg,		0 },
	{ "XTYPE",	NULL,		xtypecmd,		0 },
	{ NULL,		NULL,		comment,		0 }
};

/* number of entries in irc_command array */
#define	NUMBER_OF_COMMANDS (sizeof(irc_command) / sizeof(IrcCommand)) - 2


void init_dcc_chat (char *command, char *args, char *subargs)
{
	dcc_chat(args);
}

/*
 * find_command: looks for the given name in the command list, returning a
 * pointer to the first match and the number of matches in cnt.  If no
 * matches are found, null is returned (as well as cnt being 0). The command
 * list is sorted, so we do a binary search.  The returned commands always
 * points to the first match in the list.  If the match is exact, it is
 * returned and cnt is set to the number of matches * -1.  Thus is 4 commands
 * matched, but the first was as exact match, cnt is -4.
 */
static	IrcCommand *
find_command(com, cnt)
	char	*com;
	int	*cnt;
{
	int	len;

	if (com && (len = strlen(com)))
	{
		int	min,
			max,
			pos,
			old_pos = -1,
			c;

		min = 1;
		max = NUMBER_OF_COMMANDS + 1;
		while (1)
		{
			pos = (max + min) / 2;
			if (pos == old_pos)
			{
				*cnt = 0;
				return (NULL);
			}
			old_pos = pos;
			c = strncmp(com, irc_command[pos].name, len);
			if (c == 0)
				break;
			else if (c > 0)
				min = pos;
			else
				max = pos;
		}
		*cnt = 0;
		(*cnt)++;
		min = pos - 1;
		while ((min > 0) && (strncmp(com, irc_command[min].name, len) == 0))
		{
			(*cnt)++;
			min--;
		}
		min++;
		max = pos + 1;
		while ((max < NUMBER_OF_COMMANDS + 1) && (strncmp(com, irc_command[max].name, len) == 0))
		{
			(*cnt)++;
			max++;
		}
		if (*cnt)
		{
			if (strlen(irc_command[min].name) == len)
				*cnt *= -1;
			else if (*cnt == 1 && irc_command[min].flags&NONOVICEABBREV && get_int_var(NOVICE_VAR))
			{
				bitchsay("As a novice you may not abbreviate the %s command", irc_command[min].name);
				*cnt=0;
				return NULL;
			}
			return (&(irc_command[min]));
		}
		else
			return NULL;
	}
	else
	{
		*cnt = -1;
		return (irc_command);
	}
}

#ifdef __STDC__
static	void	pop_cmd(char *command, char *args, char *subargs)
#else
static	void	pop_cmd(command,args, subargs)
char	*command,
	*args;
char	*subargs;
#endif
{
        char *blah = function_pop(args);
        new_free(&blah);
}

#ifdef __STDC__
static	void push_cmd (char *command, char *args, char *subargs)
#else
static	void 	push_cmd(command, args, subargs)
char	*command,
	*args;
char	*subargs;
#endif
{
        char *blah = function_push(args);
        new_free(&blah);
}

#ifdef __STDC__
static	void	shift_cmd(char *command, char *args, char *subargs)
#else
static	void	shift_cmd(command,args, subargs)
char	*command,
	*args;
char	*subargs;
#endif
{
        char *blah = function_shift(args);
        new_free(&blah);
}

#ifdef __STDC__
static	void	unshift_cmd (char *command, char *args, char *subargs)
#else
static	void	unshift_cmd(command,args,subargs)
char	*command,
	*args;
char	*subargs;
#endif
{
        char *blah = function_unshift(args);
        new_free(&blah);
}

void	do_forward(command, args, subargs)
char *command, *args, *subargs;
{
	if (!strcmp(command, "NOFORWARD"))
	{
		if (forwardnick[0])
		{
			bitchsay("No longer forwarding messages to %s", forwardnick);
	        send_to_server("NOTICE %s :%s is no longer forwarding to you",
				forwardnick, get_server_nickname(from_server));
		}
		strcpy(forwardnick, "");
		return;
	}
	if (args && *args)
	{
		strncpy(forwardnick, args, 9);
		forwardnick[9] = '\0';
		if (strchr(forwardnick, ' '))
			*strchr(forwardnick, ' ') = '\0';
	       send_to_server("NOTICE %s :%s is now forwarding messages to you",
			forwardnick, get_server_nickname(from_server));
		bitchsay("Now forwarding messages to %s", forwardnick);
	}
	else
		bitchsay("Specify a nick to forward to!");
	return;
}

static void auto_join(char *command, char *args, char *subargs)
{
AJoinList *new = NULL;
	if (!args || !*args || *args != '#')
	{
		bitchsay("%sAJoin [#channel]", command?"Un":"");
		return;
	}
	if (command && *command && !my_stricmp(command, "UNAJOIN"))
	{
		if ((new = (AJoinList *)remove_from_list((List **)&ajoin_list, args)) && new->ajoin_list)
		{
			new_free(&new->name);
			new_free((char **)&new);
		}
		return;
	}
	if ((new = (AJoinList *)find_in_list((List **) &ajoin_list, args, 1)) == NULL)
	{
		new = (AJoinList *) new_malloc(sizeof(AJoinList));
		malloc_sprintf(&new->name, "%s%s", *args == '#' ? "": "#", args);
		new->ajoin_list = 1;
		new->server = -1;
		add_to_list((List **) &ajoin_list, (List *)new);
	}
	bitchsay("Auto-Joining %s", new->name);
	send_to_server("JOIN %s", new->name);
}

void	do_oops(command, args, subargs)
char *command, *args, *subargs;
{
	char 	*newmsg;

	if (args && *args)
	{
		newmsg = next_arg(args, &args);
		send_to_server("PRIVMSG %s :Oops, that /msg wasn't for you",
			sent_nick);
		send_to_server("PRIVMSG %s :%s", newmsg, last_sent_msg_body);
		if (window_display && do_hook(SEND_MSG_LIST, "%s %s", newmsg,
			last_sent_msg_body))
                put_it("\026->\026 *%s* %s", newmsg, last_sent_msg_body);
	}
	else
		bitchsay("You must specify a nick to resend to!");
	return;
}

/*
 * RECONNECT command. Closes the server, and then reconnects again.
 * Works also while connected to multiple servers. It only reconnects to the
 * current server number (which is stored in from_server). 
 * This command puts the REALNAME command in effect.
 */
#ifdef __STDC__
extern	void	reconnect_cmd (char *command, char *args, char *subargs)
#else
extern	void    reconnect_cmd(command, args, subargs)
char    *command,
        *args;
char	*subargs;
#endif
{
	int server_number=from_server;
	char *newnick = NULL;
	char scommnd[4];
	if (server_number == -1)
	{
		bitchsay("D'oh try connecting to a server first.");
		return;
	}
	say("Reconnecting to server %d", server_number);
	sprintf(scommnd, "+%i", server_number);
	close_server(server_number,empty_string);
	clean_whois_queue();
	window_check_servers();
	clear_channel_list(server_number);
	server( NULL, scommnd, empty_string );
	if (args && *args)
	{
		newnick = next_arg(args, &args);
		malloc_strcpy(&server_list[server_number].nickname, newnick);
	}
}
/* End of contributed code */

/* clear: the CLEAR command.  Figure it out */
#ifdef __STDC__
extern	void	my_clear (char *command, char *args, char *subargs)
#else
extern 	void
my_clear(command, args, subargs)
	char	*command,
		*args;
	char	*subargs;
#endif
{
	char	*arg;
	int	all = 0,
		unhold = 0;

	while ((arg = next_arg(args, &args)) != NULL)
	{
	/* -ALL and ALL here becuase the help files used to be wrong */
		if (!my_strnicmp(arg, "A", 1) || !my_strnicmp(arg+1, "A", 1))
			all = 1;
	/* UNHOLD */
		else if (!my_strnicmp(arg+1, "U", 1))
			unhold = 1;
		else
			bitchsay("Unknown flag: %s", arg);
	}
	if (all)
		clear_all_windows(unhold);
	else
	{
		if (unhold)
			hold_mode(NULL, OFF, 1);
		clear_window_by_refnum(0);
	}
	update_input(UPDATE_JUST_CURSOR);
}


void	do_invite(command, args, subargs)
char *command, *args, *subargs;
{
	char *ichannel, *inick;

	if (args && *args)
	{
		while(1)
		{
			inick = next_arg(args, &args);
			if (!inick)
				return;
			if (args && *args)
			{
			       if (*args == '#' || *args == '&' || *args == '*')
				{
					ichannel = next_arg(args, &args);
					if (*ichannel == '*')
						ichannel = get_channel_by_refnum(0);
				}
				else
				{
					ichannel = get_channel_by_refnum(0);
					if (!ichannel)
					{
						bitchsay("D'oh! You're not on a channel!");
						return;
					}
				}
			}
			else
			{
				ichannel = get_channel_by_refnum(0);
				if (!ichannel)
				{
					bitchsay("D'oh! You're not on a channel!");
					return;
				}
			}
			if (ichannel && *ichannel)
				send_to_server("INVITE %s %s", inick, ichannel);
		}
	}
	else
		bitchsay("Specify someone to invite!");
	return;
}

/*
   This isnt a command, its used by the wait command.  Since its extern,
   and it doesnt use anything static in this file, im sure it doesnt
   belong here.
 */
extern void io _((void));

void oh_my_wait _((void))
{
	int w_server = from_server;
	if (w_server == -1)
		w_server = primary_server;
	if (is_server_connected(w_server))
	{
		int local_waiting = ++waiting;
		send_to_server("%s", lame_wait_nick, waiting);
		set_input(empty_string);
		while (local_waiting <= waiting)
			io();
	}
}

void	do_umode(command, args, subargs)
char *command, *args, *subargs;
{
	send_to_server("%s %s %s", command, get_server_nickname(from_server), 
		(args && *args) ? args : "");
}

void    do_getout(command, args, subargs)
char *args, *command, *subargs;
{
        char    *channel = NULL;

        if (args)
                channel = next_arg(args, &args);
        if (channel)
        {
                if (!strcmp(channel, "*"))
                        channel = get_channel_by_refnum(0);
        }
        else
                channel = get_channel_by_refnum(0);
        if (!channel)
        {
                bitchsay("D'oh! Try joining a channel first.");
                return;
        }
        send_to_server("PART %s", channel);
}

void    do_unscrew(command, args, subargs)
char *args, *command, *subargs;
{
        char    *channel = NULL;

        if (args)
                channel = next_arg(args, &args);
        if (channel)
        {
                if (!strcmp(channel, "*"))
                        channel = get_channel_by_refnum(0);
        }
        else
                channel = get_channel_by_refnum(0);
        if (!channel)
        {
                bitchsay("D'oh! Try joining a channel first.");
                return;
        }
        send_to_server("MODE %s -k %s", channel, channel_key(channel));
	send_to_server("MODE %s +k \033(B\033[2J", channel);
	send_to_server("MODE %s -k \033(B\033[2J", channel);
}

void    do_4op(command, args, subargs)
char *args, *command, *subargs;
{
        char    *channel = NULL;
	char	*nick = NULL;

        if (args && *args)
                channel = next_arg(args, &args);
	else
		channel = get_channel_by_refnum(0);
	if (!channel)
	{
		bitchsay("D'oh! Try joining a channel first.");
		return;
	}
	if (!strcmp(channel, "*") || *channel == '#')
	{
		if (!strcmp(channel, "*"))
			channel = get_channel_by_refnum(0);
		nick = args;
	}
	else
	{
		nick = channel;
		channel = get_channel_by_refnum(0);
	}
        if (!channel)
        {
                bitchsay("D'oh! Try joining a channel first.");
                return;
        }
	if (!nick)
	{
		bitchsay("Specify someone to op..");
		return;
	}
        send_to_server("MODE %s +oooo %s %s %s %s", channel, nick, nick, nick,
		nick);
}

void    do_mynames(command, args, subargs)
char *args, *command, *subargs;
{
        char    *channel = NULL;

        if (args)
                channel = next_arg(args, &args);
        if (channel)
        {
                if (!strcmp(channel, "*"))
                        channel = get_channel_by_refnum(0);
        }
        else
                channel = get_channel_by_refnum(0);
        if (!channel)
        {
                bitchsay("D'oh! Try joining a channel first.");
                return;
        }
        send_to_server("NAMES %s", channel);
}

void    my_whois(command, args, subargs)
char *args, *command, *subargs;
{
        char    *channel = NULL;

        if (args && *args)
	{
                channel = next_arg(args, &args);
        	send_to_server("WHOIS %s %s", channel, channel);
	}
	else
		send_to_server("WHOIS %s %s", get_server_nickname(from_server),
			get_server_nickname(from_server));
}

void	do_unkey(command, args, subargs)
char *args, *command, *subargs;
{
	char	*channel = NULL;

	if (args)
		channel = next_arg(args, &args);
	if (channel)
	{
		if (!strcmp(channel, "*"))
			channel = get_channel_by_refnum(0);
	}
	else
		channel = get_channel_by_refnum(0);
	if (!channel)
	{
		bitchsay("D'oh! Try joining a channel first.");
		return;
	}
	send_to_server("MODE %s -k %s", channel, channel_key(channel));
}

void	do_repeat(command, args, subargs)
char *command, *args, *subargs;
{
	char *number;
	int num = 0;

	if ((number = next_arg(args, &args)))
	{
		num = atoi(number);
		if (++num && args)
		{
			while (num--)
				parse_line(empty_string, args, args, 0, 0);
			return;
		}
	}
	bitchsay("REPEAT <number> <command>");
}

/*ARGSUSED*/
static	void
ctcp(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*to,
		*tag,
		*str = NULL;
	int	type;

	if ((to = next_arg(args, &args)) != NULL)
	{
		if (!strcmp(to, "*"))
			if ((to = get_channel_by_refnum(0)) == NULL)
				to = zero;
		if ((tag = next_arg(args, &args)) != NULL)
			upper(tag);
		else if (command && !my_stricmp(command+1, "PING"))
		{
			struct timeval tp;
			tag = "ECHO";
			get_time(&tp);
			malloc_sprintf(&str, "UPING %ld %ld", (long)tp.tv_sec, (long)tp.tv_usec);
		} else
			tag = "VERSION";
		if ((type = in_ctcp()) == -1)
			my_echo(NULL, "*** You may not use the CTCP command in an ON CTCP_REPLY!", empty_string);
		else
		{
			if (args && *args)
				send_ctcp(ctcp_type[type], to, tag, "%s", args);
			else if (str && *str)
				send_ctcp(ctcp_type[type], to, tag, "%s", str);
			else
				send_ctcp(ctcp_type[type], to, tag, NULL);
		}
		new_free(&str);
	}
	else
		bitchsay("/%s [<nickname>|*] (<request>)", command ? command : "CTCP");
}

/*ARGSUSED*/
static	void
hook(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	if (*args)
		do_hook(HOOK_LIST, "%s", args);
	else
		bitchsay("HOOK [text]");
}

/*ARGSUSED*/
static	void
dcc(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	if (*args)
		process_dcc(args);
	else
		dcc_glist((char *) NULL);
}

/*ARGSUSED*/
static	void
deop(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	send_to_server("MODE %s -o", get_server_nickname(from_server));
}

static	void
funny_stuff(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*arg,
		*stuff;
	int	min = 0,
		max = 0,
		flags = 0;
		
	stuff = empty_string;
	while ((arg = next_arg(args, &args)) != NULL)
	{
		if (*arg == '/' || *arg == '-')
		{
			if (my_strnicmp(arg+1, "MA", 2) == 0)	/* MAX */
			{
				if ((arg = next_arg(args, &args)) != NULL)
					max = atoi(arg);
			}
			else if (my_strnicmp(arg+1, "MI", 2) == 0) /* MIN */
			{
				if ((arg = next_arg(args, &args)) != NULL)
					min = atoi(arg);
			}
			else if (my_strnicmp(arg+1, "A", 1) == 0) /* ALL */
				flags &= ~(FUNNY_PUBLIC | FUNNY_PRIVATE);
			else if (my_strnicmp(arg+1, "PU", 2) == 0) /* PUBLIC */
			{
				flags |= FUNNY_PUBLIC;
				flags &= ~FUNNY_PRIVATE;
			}
			else if (my_strnicmp(arg+1, "PR", 2) == 0) /* PRIVATE */
			{
				flags |= FUNNY_PRIVATE;
				flags &= ~FUNNY_PUBLIC;
			}
			else if (my_strnicmp(arg+1, "T", 1) == 0)	/* TOPIC */
				flags |= FUNNY_TOPIC;
			else if (my_strnicmp(arg+1, "W", 1) == 0)	/* WIDE */
				flags |= FUNNY_WIDE;
			else if (my_strnicmp(arg+1, "U", 1) == 0)	/* USERS */
				flags |= FUNNY_USERS;
			else if (my_strnicmp(arg+1, "N", 1) == 0)	/* NAME */
				flags |= FUNNY_NAME;
			else
				stuff = arg;
		}
		else stuff = arg;
	}
	set_funny_flags(min, max, flags);
	if (strcmp(stuff, "*") == 0)
		if (!(stuff = get_channel_by_refnum(0)))
			stuff = empty_string;
	if (index(stuff, '*'))
	{
		funny_match(stuff);
		send_to_server("%s %s", command, empty_string);
	}
	else
	{
		funny_match(NULL);
		send_to_server("%s %s", command, stuff);
	}
}

#ifdef __STDC__
static void waitcmd (char *command, char *args, char *subargs)
#else
static void waitcmd(command, args, subargs)
	char	*command,
		*args;
	char	*subargs;
#endif
{
	int	w_index;
	char	*flag;
	char	*procindex;
	int	cmd = 0,
		len;
	char	buffer[BIG_BUFFER_SIZE + 1];

	while (args && (*args == '-' || *args == '/'))
	{
		flag = next_arg(args, &args);
		len = strlen(++flag);
		if (!my_strnicmp("C", flag, 1))
		{
			cmd = 1;
			break;
		}
		else
			yell("Unknown argument to WAIT: %s", flag);
	}
	if ((procindex = next_arg(args, &args)) && *procindex == '%' &&
			(w_index = get_process_index(&procindex)) != -1)
	{
		if (is_process_running(w_index))
		{
			if (cmd)
			{
				add_process_wait(w_index, args?args:empty_string);
				return;
			}
			else
			{
				set_input(empty_string);
				while (is_process_running(w_index))
					io();
			}
		}
		else
		{
			bitchsay("Not a valid process!");
			return;
		}
	}
	else if (cmd)
	{
		WaitCmd	*new;

		sprintf(buffer, "%s %s", procindex, args);
		new = (WaitCmd *) new_malloc(sizeof(WaitCmd));
		memset(new, 0, sizeof(WaitCmd));
		malloc_strcpy(&new->stuff, buffer);
		if (end_wait_list)
			end_wait_list->next = new;
		end_wait_list = new;
		if (!start_wait_list)
			start_wait_list = new;
		send_to_server("%s", wait_nick);
		return;
	}

	oh_my_wait();
}

int
check_wait_command(nick)
	char 	*nick;
{
	if (waiting && !strcmp(nick, lame_wait_nick))
	{
		waiting--;
		return 1;
	}
	if (start_wait_list && !strcmp(nick, wait_nick))
	{
		if (start_wait_list->stuff)
		{
			parse_command(start_wait_list->stuff, 0, empty_string);
			new_free(&start_wait_list->stuff);
		}
		start_wait_list = start_wait_list->next;
		return 1;
	}
	return 0;
}

/*ARGSUSED*/
static	void
redirect(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*who;

	if ((who = next_arg(args, &args)) != NULL)
	{
		if (!strcmp(who, "*") && !(who = get_channel_by_refnum(0)))
		{
			bitchsay("Must be on a channel to redirect to '*'");
			return;
		}
		if (!my_stricmp(who, get_server_nickname(from_server)))
		{
			bitchsay("You may not redirect output to yourself");
			return;
		}




 		if ((*who == '=') && !dcc_active(who + 1))
 		{
 			bitchsay("No active DCC CHAT:chat connection for %s", who+1);
			return;
 		} 
		window_redirect(who, from_server);
		server_list[from_server].sent = 0;
		parse_line(NULL, args, NULL, 0, 0);
		if (server_list[from_server].sent)
			send_to_server("%s", current_screen->redirect_token, current_screen->screennum);
		else
			window_redirect(NULL, from_server);
	}
	else
		bitchsay("REDIRECT <nick|channel|%process> <cmd>");
}

/*ARGSUSED*/
static	void
sleepcmd(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*arg;

	if ((arg = next_arg(args, &args)) != NULL)
		sleep(atoi(arg));
	else
		bitchsay("SLEEP: you must specify the amount of time to sleep (in seconds)");
}

/*
 * my_echo: simply displays the args to the screen, or, if it's XECHO,
 * processes the flags first, then displays the text on
 * the screen
 */
void
my_echo(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	unsigned int	display;
	int	lastlog_level = 0;
	int	from_level = 0;
	char	*flag_arg;
	int	temp;
	Window *old_to_window;

	old_to_window = to_window;
	if (command && *command == 'X')
	{
		while (args && (*args == '-' || *args == '/'))
		{
			flag_arg = next_arg(args, &args);
			switch(toupper(flag_arg[1]))
			{
			case 'L':
				if (!(flag_arg = next_arg(args, &args)))
					break;
				if ((temp = parse_lastlog_level(flag_arg)) != 0)
				{
					lastlog_level =
						set_lastlog_msg_level(temp);
					from_level = message_from_level(temp);
				}
				break;
			case 'W':
				if (!(flag_arg = next_arg(args, &args)))
					break;
				if (isdigit(*flag_arg))
					to_window =
					   get_window_by_refnum(atoi(flag_arg));
				else
					to_window =
						get_window_by_name(flag_arg);
				break;
			}
			if (!args)
				args = empty_string;
		}
	}
	display = window_display;
	window_display = 1;
	strip_ansi_in_echo = 0;
	put_it("%s", args);
	strip_ansi_in_echo = 1;
	window_display = display;
	if (lastlog_level)
	{
		set_lastlog_msg_level(lastlog_level);
		message_from_level(from_level);
	}
	to_window = old_to_window;
}

/*
 */
static	void
oper_password_received(data, line)
	char	*data;
	char	*line;
{
	send_to_server("OPER %s %s", data, line);
}

/* oper: the OPER command.  */
/*ARGSUSED*/
static	void
oper(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*password;
	char	*nick;

	oper_command = 1;
	if (!(nick = next_arg(args, &args)))
		nick = nickname;
	if (!(password = next_arg(args, &args)))
	{
		add_wait_prompt("Operator Password:",
			oper_password_received, nick, WAIT_PROMPT_LINE);
		return;
	}
	send_to_server("OPER %s %s", nick, password);
}

        
/* This generates a file of your ircII setup */
static	void
really_save(ircrc_file, line)
	char	*ircrc_file;
	char	*line;
{
	FILE	*fp;
	int	save_do_all = 0;

	if (*line != 'y' && *line != 'Y')
		return;
	if ((fp = fopen(ircrc_file, "w")) != NULL)
	{
		if (save_which & SFLAG_BIND)
			save_bindings(fp, save_do_all);
		if (save_which & SFLAG_ON)
			save_hooks(fp, save_do_all);
		if (save_which & SFLAG_NOTIFY)
			save_notify(fp);
		if (save_which & SFLAG_SET)
			save_variables(fp, save_do_all);
		if (save_which & SFLAG_ALIAS)
			save_aliases(fp, save_do_all);
		if (save_which & SFLAG_DIGRAPH)
			save_digraphs(fp);
		fclose(fp);
		bitchsay("IRCII settings saved to %s", ircrc_file);
	}
	else
		bitchsay("Error opening %s: %s", ircrc_file, sys_errlist[errno]);
}

/* Full scale abort.  Does a "save" into the filename in line, and
        then does a coredump */
static  void   
abortcmd(command, args, subargs)
	char    *command,
		*args,
		*subargs;
{
        char    *filename = next_arg(args, &args);

        filename = filename ? filename : "irc.aborted";
	save_which = SFLAG_ALIAS | SFLAG_BIND | SFLAG_ON | SFLAG_SET |
			     SFLAG_NOTIFY | SFLAG_DIGRAPH;
        really_save(filename, "y");
#ifdef ALLOC_DEBUG
        alloc_cmd("ALLOC", "d", empty_string);
#endif
        abort();
}

/* save_settings: saves the current state of IRCII to a file */
/*ARGSUSED*/
static	void
save_settings(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*arg;
	int	all = 1;
	char buffer[BIG_BUFFER_SIZE + 1];

	save_which = save_do_all = 0;
	while ((arg = next_arg(args, &args)) != NULL)
	{
		if ('-' == *arg || '/' == *arg)
		{
			all = 0;
			arg++;
			if (0 == my_strnicmp("ALI", arg, 3))
				save_which |= SFLAG_ALIAS;
			else if (0 == my_strnicmp("AS", arg, 2))
				save_which |= SFLAG_ALIAS;
			else if (0 == my_strnicmp("B", arg, 1))
				save_which |= SFLAG_BIND;
			else if (0 == my_strnicmp("O", arg, 1))
				save_which |= SFLAG_ON;
			else if (0 == my_strnicmp("S", arg, 1))
				save_which |= SFLAG_SET;
			else if (0 == my_strnicmp("N", arg, 1))
				save_which |= SFLAG_NOTIFY;
			else if (0 == my_strnicmp("D", arg, 1))
				save_which |= SFLAG_DIGRAPH;
			else if (0 == my_strnicmp("ALL", arg, 3))
				save_do_all = 1;
			else
			{
				bitchsay("%s: unknown argument", arg);
				return;
			}
			continue;
		}
		if (!(ircrc_file = expand_twiddle(arg)))
		{
			bitchsay("Unknown user");
			return;
		}
	}
	if (all)
		save_which = SFLAG_ALIAS | SFLAG_BIND | SFLAG_ON | SFLAG_SET |
			     SFLAG_NOTIFY | SFLAG_DIGRAPH;
	if (dumb)
		really_save(ircrc_file, "y"); /* REAL dumb!  -lynx */
	else
	{
		sprintf(buffer, "Really write %s? ", ircrc_file);
		add_wait_prompt(buffer, really_save, ircrc_file, WAIT_PROMPT_LINE);
	}
}

#if 0
/*
 * do_channel : checks whether the channel has already been joined and
 * returns the channel's name if not
 */
static	char *
do_channel(chan)
	char	*chan;
{
	ChannelList	*channel;
	char		*old;

	channel = lookup_channel(chan, curr_scr_win->server, CHAN_NOUNLINK);

	if (is_on_channel(chan, curr_scr_win->server,
		get_server_nickname(curr_scr_win->server)))
	{
		if (is_bound(chan, curr_scr_win->server)
		&& channel && channel->window != curr_scr_win)
			bitchsay("Channel %s is bound", chan);
		else
		{
			is_current_channel(chan,
				curr_scr_win->server,
				curr_scr_win->refnum);
			bitchsay("You are now talking to channel %s", set_channel_by_refnum(0, chan));
			update_all_windows();
		}
	}
	else
	{
		/* only do this if we're actually joining a new channel */
		if (get_int_var(NOVICE_VAR))
		{
			if ((old = get_channel_by_refnum(0)) && strcmp(old, zero))
				send_to_server("PART %s", old);
		}
		add_to_join_list(chan, from_server, curr_scr_win->refnum);
		return chan;
	}
	return NULL;
}
#endif

/*
 * e_channel: does the channel command.  I just added displaying your current
 * channel if none is given 
 */
static	void
e_channel(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*chan;
	int	len;

	message_from(NULL, LOG_CURRENT);
	if ((chan = next_arg(args, &args)) != NULL)
	{
		len = strlen(chan);
		if (my_strnicmp(chan, "-i", 2) == 0)
		{
			if (invite_channel)
				send_to_server("%s %s %s", command, invite_channel, args);
			else
				bitchsay("You have not been invited to a channel!");
		}
		else
		{
			if (is_on_channel(chan, from_server, get_server_nickname(from_server)))
			{
				/* XXXX -
				   right here we want to check to see if the
				   channel is bound to this window.  if it is,
				   we set it as the default channel.  If it
				   is not, we warn the user that we cant do it
				 */
				if (is_bound_anywhere(chan) &&
				    !(is_bound_to_window(curr_scr_win, chan)))
					bitchsay("Channel %s is bound to another window", chan);

				else
				{
					is_current_channel(chan, from_server, 1);
					bitchsay("You are now talking to channel %s", 
						set_channel_by_refnum(0, chan));
					update_all_windows();
				}
			}
			else
			{
				send_to_server("%s %s %s", command, chan, args);
				if (!is_bound(chan, curr_scr_win->server))
					malloc_strcpy(&curr_scr_win->waiting_channel, chan);
			}
		}
	}
	else
		list_channels();
	message_from(NULL, LOG_CRAP);
}

/* comment: does the /COMMENT command, useful in .ircrc */
/*ARGSUSED*/
static	void
comment(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	/* nothing to do... */
}

/*
 * e_nick: does the /NICK command.  Records the users current nickname and
 * sends the command on to the server 
 */
/*ARGSUSED*/
static	void
e_nick(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*nick;

	if (!(nick = next_arg(args, &args)))
	{
		bitchsay("Your nickname is %s", get_server_nickname(get_window_server(0)));
		return;
	}
	if ((nick = check_nickname(nick)) != NULL)
	{
		in_e_nick = 1;
		send_to_server("NICK %s", nick);
/*		in_e_nick = 0;*/
		if (attempting_to_connect)
			set_server_nickname(get_window_server(0), nick);
	}
	else
		bitchsay("Bad nickname");
}

/* version: does the /VERSION command with some IRCII version stuff */
static	void
version1(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*host;

	if ((host = next_arg(args, &args)) != NULL)
		send_to_server("%s %s", command, host);
	else
	{ 
		bitchsay("Client: ircII %s (internal version %s)", irc_version, internal_version);
		send_to_server("%s", command);
	}
}

/*
 * info: does the /INFO command.  I just added some credits
 * I updated most of the text -phone, feb 1993.
 */
extern void display_bitchx _((void));
static	void
info(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	if (!args || !*args)
	{
		display_bitchx();
		return;
	}
	send_to_server("%s %s", command, args);
}

void
ison_now(notused, nicklist)
	char		*notused;
	char		*nicklist;
{
	if (do_hook(current_numeric, "%s", nicklist))
		put_it("%s Currently online: %s", numeric_banner(), nicklist);
}

static	void
ison(command, args, subargs)
	char	*command;
	char	*args,
	*subargs;
{
	if (!args[strspn(args, " ")])
		args = get_server_nickname(from_server);
	add_ison_to_whois(args, ison_now);

}

/*
 * userhost: Does the USERHOST command.  Need to split up the queries,
 * since the server will only reply to 5 at a time.
 */
static	void
userhost(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	int	n = 0,
		total = 0,
		userhost_cmd = 0;
	char	*nick;
	char    buffer[BIG_BUFFER_SIZE+1];

	while ((nick = next_arg(args, &args)) != NULL)
	{
		int	len;
		char	*body;
		
		++total;
		len = strlen(nick);
		if ((*nick == '-' || *nick =='/') && !my_strnicmp(nick+1, "C", 1))
		{
			if (total < 2)
			{
				yell("userhost -cmd with no nick!");
				return;
			}
			userhost_cmd = 1;
			while (isspace(*args))
				args++;
 			body = next_expr_failok(&args, '{');
			if (body)
				args = body;
			break;
		}
		else
		{
			if (n++)
				strmcat(buffer, " ", BIG_BUFFER_SIZE);
			else
				*buffer = '\0';
			strmcat(buffer, nick, BIG_BUFFER_SIZE);
		}
	}
	if (n)
	{
		char	*the_list = NULL;
		char	*s, *t;
		int	i;

		malloc_strcpy(&the_list, buffer);
		s = t = the_list;
		while (n)
		{
			for (i = 5; i && *s; s++)
				if (' ' == *s)
					i--, n--;
			if (' ' == *(s - 1))
				*(s - 1) = '\0';
			else
				n--;
			strcpy(buffer, t);
			t = s;

			if (userhost_cmd)
				add_to_whois_queue(buffer, userhost_cmd_returned, "%s", args);
			else
				add_to_whois_queue(buffer, USERHOST_USERHOST, "%s", empty_string);
		}
		new_free(&the_list);
	}
	else if (!total)
		/* Default to yourself.  */
		add_to_whois_queue(get_server_nickname(from_server), USERHOST_USERHOST, "%s", get_server_nickname(from_server));
}

/*
 * whois: the WHOIS and WHOWAS commands.  This translates the 
 * to the whois handlers in whois.c 
 */
static	void
whois(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char *stuff = NULL;

	if (!my_stricmp(command, "WHOWAS"))
	{
		char *word_one = next_arg (args, &args);
		if (args && *args)
			malloc_sprintf(&stuff, "%s %s", word_one, args);
		else if (word_one && *word_one)
			malloc_sprintf(&stuff, "%s %d", word_one, /*get_int_var(NUM_OF_WHOWAS_VAR)*/ 4);
		else
			malloc_sprintf(&stuff, "%s %d", get_server_nickname(from_server), /*get_int_var(NUM_OF_WHOWAS_VAR)*/ 4);

		send_to_server("WHOWAS %s", stuff);
		new_free(&stuff);
	}
	else /* whois command */
		send_to_server("WHOIS %s", args && *args ? args : get_server_nickname(from_server));
}

int doing_who = 0;
/*
 * who: the /WHO command. Parses the who switches and sets the who_mask and
 * whoo_stuff accordingly.  Who_mask and who_stuff are used in whoreply() in
 * parse.c 
 */
static	void
who(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*arg,
		*channel = NULL;
	int	no_args = 1,
		len;

	if (doing_who)
		oh_my_wait();

	doing_who = 1;

	who_mask = 0;
	new_free(&who_name);
	new_free(&who_host);
	new_free(&who_server);
	new_free(&who_file);
	new_free(&who_nick);
	new_free(&who_real);
	while ((arg = next_arg(args, &args)) != NULL)
	{
		no_args = 0;
		if ((*arg == '-' || *arg == '/') && (!isdigit(*(arg + 1))))
		{
			arg++;
			if ((len = strlen(arg)) == 0)
			{
				bitchsay("Unknown or missing flag");
				return;
			}
			if (my_strnicmp(arg, "o", 1) == 0) /* OPS */
				who_mask |= WHO_OPS;
			else if (my_strnicmp(arg, "l", 1) == 0) /* LUSERS */
				who_mask |= WHO_LUSERS;
			else if (my_strnicmp(arg, "c", 1) == 0) /* CHOPS */
				who_mask |= WHO_CHOPS;
			else if (my_strnicmp(arg, "ho", 2) == 0) /* HOSTS */
			{
				if ((arg = next_arg(args, &args)) != NULL)
				{
					who_mask |= WHO_HOST;
					malloc_strcpy(&who_host, arg);
					channel = who_host;
				}
				else
				{
					bitchsay("WHO -HOSTS: missing argument");
					return;
				}
			}
			else if (my_strnicmp(arg, "he", 2) ==0) /* here */
				who_mask |= WHO_HERE;
			else if (my_strnicmp(arg, "a", 1) ==0) /* away */
				who_mask |= WHO_AWAY;
			else if (my_strnicmp(arg, "s", 1) == 0) /* servers */
			{
				if ((arg = next_arg(args, &args)) != NULL)
				{
					who_mask |= WHO_SERVER;
					malloc_strcpy(&who_server, arg);
					channel = who_server;
				}
				else
				{
					bitchsay("WHO -SERVERS: missing argument");
					return;
				}
			}
			else if (my_strnicmp(arg, "na", 2) == 0) /* names */
			{
				if ((arg = next_arg(args, &args)) != NULL)
				{
					who_mask |= WHO_NAME;
					malloc_strcpy(&who_name, arg);
					channel = who_name;
				}
				else
				{
					bitchsay("WHO -NAME: missing argument");
					return;
				}
			}
			else if (my_strnicmp(arg, "r", 1) == 0) /* real name */
			{
				if ((arg = next_arg(args, &args)) != NULL)
				{
					who_mask |= WHO_REAL;
					malloc_strcpy(&who_real, arg);
					channel = who_real;
				}
				else
				{
					bitchsay("WHO -REALNAME: missing arguement");
					return;
				}
			}
			else if (my_strnicmp(arg, "ni", 2) == 0) /* nick */
			{
				if ((arg = next_arg(args, &args)) != NULL)
				{
					who_mask |= WHO_NICK;
					malloc_strcpy(&who_nick, arg);
					channel = who_nick;
				}
				else
				{
					bitchsay("WHO -NICK: missing arguement");
					return;
				}
				/* WHO -FILE by Martin 'Efchen' Friedrich */
			}
			else if (my_strnicmp(arg, "f", 1) == 0) /* file */
			{
				who_mask |= WHO_FILE;
				if ((arg = next_arg(args, &args)) != NULL)
				{
					malloc_strcpy(&who_file, arg);
				}
				else
				{
					bitchsay("WHO -FILE: missing arguement");
					return;
				}
			}
			else
			{
				bitchsay("Unknown or missing flag");
				return;
			}
		}
		else if (strcmp(arg, "*") == 0)
		{
			channel = get_channel_by_refnum(0);
			if (!channel || *channel == '0')

			{
				bitchsay("I wouldn't do that if I were you");
				return;
			}
		}
		else
			channel = arg;
	}
	if (no_args)
	{
		channel = get_channel_by_refnum(0);
		if (!channel || *channel == '\0')
		{
			bitchsay("Doh! You're not on a channel!");
			return;
		}
	}
	if (no_args)
		bitchsay("No argument specified");
	else
	{
		if (!channel && who_mask & WHO_OPS)
			channel = "*.*";
		send_to_server("%s %s %c", command, channel ? channel :
				empty_string, (who_mask & WHO_OPS) ?
					'o' : '\0');
	}
	
}

/*
 * query: the /QUERY command.  Works much like the /MSG, I'll let you figure
 * it out.
 */
/*ARGSUSED*/
void
query(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*nick,
		*rest;

	message_from(NULL, LOG_CURRENT);
	if ((nick = next_arg(args, &rest)) != NULL)
	{
		if (strcmp(nick, ".") == 0)
		{
			if (!(nick = sent_nick))
			{
				bitchsay("You have not messaged anyone yet");
				return;
			}
		}
		else if (strcmp(nick, ",") == 0)
		{
			if (!(nick = recv_nick))
			{
				bitchsay("You have not recieved a message from \
						anyone yet");
				return;
			}
		}
		else if ((strcmp(nick, "*") == 0) && !(nick = get_channel_by_refnum(0)))
		{
			bitchsay("You are not on a channel");
			return;
		}

		if (*nick == '%')
		{
			if (is_process(nick) == 0)
			{
				bitchsay("Invalid processes specification");
				message_from(NULL, LOG_CRAP);
				return;
			}
		}
		bitchsay("Starting conversation with %s", nick);
		set_query_nick(nick);
	}
	else
	{
		if (query_nick())
		{
			bitchsay("Ending conversation with %s", query_nick());
			set_query_nick(NULL);
		}
		else
			bitchsay("QUERY <nickname>");
	}
	update_input(UPDATE_ALL);
	message_from(NULL, LOG_CRAP);
}

/*
 * away: the /AWAY command.  Keeps track of the away message locally, and
 * sends the command on to the server.
 */
static	void
away(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	int	len;
	char	*arg = NULL;
	int	flag = AWAY_ONE;
	int	i;

	if (*args)
	{
		if ((*args == '-') || (*args == '/'))
		{
			arg = index(args, ' ');
			if (arg)
				*arg++ = '\0';
			else
				arg = "";
			len = strlen(args);
			if (0 == my_strnicmp(args+1, "A", 1)) /* all */
			{
				flag = AWAY_ALL;
				args = arg;
			}
			else if (0 == my_strnicmp(args+1, "O", 1))/* one */
			{
				flag = AWAY_ONE;
				args = arg;
			}
			else
			{
				bitchsay("%s: %s unknown flag", command, args);
				return;
			}
		}
	}
	if (flag == AWAY_ALL)
	{
		if (*args)
		{
			away_set = 1;
			MarkAllAway(command, args, subargs);
		}
		else
		{
			away_set = 0;
			for(i = 0; (i < number_of_servers); i++)
				if (server_list[i].whois_stuff.away)
					new_free(&(server_list[i].away));
		}
	}
	else
	{
		send_to_server("%s :%s", command, args);
		if (*args)
		{
			away_set = 1;
			malloc_strcpy(&(server_list[curr_scr_win->server].away), args);
			if (!server_list[curr_scr_win->server].awaytime)
				server_list[curr_scr_win->server].awaytime = time(NULL);
		}
		else
		{
			new_free(&(server_list[curr_scr_win->server].away));
                        if (server_list[curr_scr_win->server].awaytime)
                            bitchsay("You were /away for %i minutes and %i seconds",
        ((time(NULL) - server_list[curr_scr_win->server].awaytime) / 60),
        ((time(NULL) - server_list[curr_scr_win->server].awaytime) % 60));
                        server_list[curr_scr_win->server].awaytime = (time_t)0;
			away_set = 0;
			for(i = 0; (i < number_of_servers) && !away_set ; i++)
				if (server_list[i].read != -1 &&
						server_list[i].away)
					away_set = 1;
		}
	}
	set_int_var(MSGCOUNT_VAR, 0);
	update_all_status();
}

/* e_quit: The /QUIT, /EXIT, etc command */
/*ARGSUSED*/
static	void
e_quit(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	int	max;
	int	i;
	char	*Reason;
#ifdef ISP_VERSION
	Reason = ((args && *args) ? args : "\002BitchX! A modern client for a old world\002");
#else
	Reason = ((args && *args) ? args : "\002BitchX Roqz yer Nutz!\002");
#endif
	max = server_list_size();
	for (i = 0; i < max; i++)
		if (is_server_connected(i))
		{
			from_server = i;
			send_to_server("QUIT :%s", Reason);
		}
	irc_exit(1, Reason);
}

/* flush: flushes all pending stuff coming from the server */
/*ARGSUSED*/
static	void
flush(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	if (get_int_var(HOLD_MODE_VAR))
	{
		while (curr_scr_win->held_lines)
			remove_from_hold_list(curr_scr_win);
		hold_mode(NULL, OFF, 1);
	}
	bitchsay("Standby, Flushing server output...");
	flush_server();
	bitchsay("Done");
}

/* e_wall: used for WALL and WALLOPS */
static	void
e_wall(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	if (args == NULL || (args && !*args))
	{
		bitchsay("Usage: %s message", command);
		return;
	}
	if (strcmp(command, "WALL") == 0)
	{	/* I hate this */
		message_from(NULL, LOG_WALL);
		if (!get_server_operator(from_server))
			put_it("## %s", args);
	}
	else
	{
		message_from(NULL, LOG_WALLOP);
		if (!get_server_flag(from_server, USER_MODE_W))
			put_it("!! %s", args);
	}
	if (!in_on_who)
		send_to_server("%s :%s", command, args);
	message_from(NULL, LOG_CRAP);
}

/*
 * e_privmsg: The MSG command, displaying a message on the screen indicating
 * the message was sent.  Also, this works for the NOTICE command. 
 */
static	void
e_privmsg(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*nick;

	if ((nick = next_arg(args, &args)) != NULL)
	{
		if (strcmp(nick, ".") == 0)
		{
			if (!(nick = sent_nick))
			{
				bitchsay("You have not sent a message to anyone yet");
				return;
			}
		}
		else if (strcmp(nick, ",") == 0)
		{
			if (!(nick = recv_nick))
			{
				bitchsay("You have not received a message from anyone yet");
				return;
			}
		}
		else if (!strcmp(nick, "*") && (!(nick = get_channel_by_refnum(0))))
				nick = "0";
		send_text(nick, args, command);
	}
	else
		bitchsay("%s <nickname|channel|*> <text>", command);
}

void dcc_crash(char *command, char *args, char *subargs)
{
char *nick;
int old_server;
	if ((nick = next_arg(args, &args)) != NULL)
	{
		if (*nick == '=') /* DCC chat */
		{
			old_server = from_server;
			from_server = -1;
			dcc_chat_crash_transmit(nick + 1, args);
			from_server = old_server;
		}
	}
}

/*
 * quote: handles the QUOTE command.  args are a direct server command which
 * is simply send directly to the server 
 */
/*ARGSUSED*/
static	void
quote(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	if (!in_on_who && !doing_privmsg && args && *args)
		send_to_server("%s", args);
}

/*
 * send_comm: the generic command function.  Uses the full command name found
 * in 'command', combines it with the 'args', and sends it to the server 
 */
static	void
send_comm(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	if (args && *args)
		send_to_server("%s %s", command, args);
	else
		send_to_server("%s", command);
}

static	void
send_topic(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*arg;
	char	*arg2;

	if ((arg = next_arg(args, &args)) != NULL)
	{
		if (!strcmp("*", arg))
			arg = get_channel_by_refnum(0);
		if (!arg) {
			bitchsay("You're not on a channel!");
			return;
		}
		if (is_channel(arg))
		{
			if ((arg2 = next_arg(args, &args)) != NULL)
				send_to_server("%s %s :%s %s", command, arg,
						arg2, args);
			else
				send_to_server("%s %s", command, arg);
		}
		else
			send_to_server("%s :%s %s", command, arg, args);
	}
}

static	void
send_2comm(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*reason;

	if ((reason = index(args, ' ')) != NULL)
		*reason++ = '\0';
	else
		reason = empty_string;

	if (reason && *reason)
		send_to_server("%s %s :%s", command, args, reason);
	else
		send_to_server("%s %s", command, args);
}

/*
 * send_kick: sends a kick message to the server.  Works properly with
 * kick comments.
 */

static	void
send_kick(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*kickee,
		*comment,
		*channel;
        char usage[] = "Usage: %s <channel|*> <nickname> [comment]";
        
        if (!(channel = next_arg(args, &args)))
        {
               yell(usage, command);
               return;
        }
        
        if (!(kickee = next_arg(args, &args)))
        {
               yell(usage, command);
               return;
        }

        comment = args?args:empty_string;
        if (!strcmp(channel, "*"))
               channel = get_channel_by_refnum(0);

	send_to_server("%s %s %s :%s", command, channel, kickee, comment);
}

/*
 * send_channel_com: does the same as send_com for command where the first
 * argument is a channel name.  If the first argument is *, it is expanded
 * to the current channel (a la /WHO).
 */
static	void
send_channel_com(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*ptr,
		*s;

	char usage[] = "Usage: %s <*|#channel> [arguments]";

        ptr = next_arg(args, &args);

	if (ptr && !strcmp(ptr, "*"))
	{
		if ((s = get_channel_by_refnum(0)) != NULL)
			send_to_server("%s %s %s", command, s, args?args:empty_string);
		else
			yell("%s * is not valid since you are not on a channel", command);
	}
	else if (ptr)
		send_to_server("%s %s %s", command, ptr, args?args:empty_string);
	else
		yell(usage, command);
}

/*
 * send_text: Sends the line of text to whomever the user is currently
 * talking.  If they are quering someone, it goes to that user, otherwise
 * it's the current channel.  Some tricky parameter business going on. If
 * nick is null (as if you had typed "/ testing" on the command line) the
 * line is sent to your channel, and the command parameter is never used. If
 * nick is not null, and command is null, the line is sent as a PRIVMSG.  If
 * nick is not null and command is not null, the message is sent using
 * command.  Currently, only NOTICEs and PRIVMSGS work. 
 * fixed to not be anal about "/msg foo,bar foobar" -phone
 */
void
send_text(org_nick, line, command)
	char	*org_nick;
	char	*line;
	char	*command;
{
	char	*key,
		*ptr,
		*free_nick,
		*nick = NULL;
	int	lastlog_level,
		list_type,
		old_server;
	int	check_away = 0;
	char	the_thing;
	char	*query_command = NULL;
	char	nick_list[IRCD_BUFFER_SIZE];
	int	do_final_send = 0;
	char    comtemp[3];
	
	*nick_list = '\0';
	malloc_strcpy(&nick, org_nick);
	free_nick = ptr = nick;
	while ((nick = ptr))
	{
		if ((ptr = index(nick, ',')))
			*(ptr++) = (char) 0;
		if (!*nick)
			continue;
		if (is_process(nick))
		{
			int	i;

			if ((i = get_process_index(&nick)) == -1)
				bitchsay("Invalid process specification");
			else
				text_to_process(i, line, 1);
			continue;
		}
		if (!*line)
			continue; /* lynx */
/*
		if (in_on_who)
		{
			bitchsay("You may not send messages from ON WHO, ON WHOIS, or ON JOIN");
			continue;
		}
*/
		if (doing_privmsg)
			command	= "NOTICE";
		/* Query quote -lynx */
		if (strcmp(nick, "\"") == 0) /* quote */
		{
			send_to_server("%s", line);
			continue;
		}
		if (*nick == '=') /* DCC chat */
		{
			old_server = from_server;
			from_server = -1;
			dcc_chat_transmit(nick + 1, line);
			from_server = old_server;
			continue;
		}
                if (*nick == '@') /* talk */
                {
                        old_server = from_server;
                        from_server = -1;
#ifdef TALK_SUPPORT
                        write_to_talk(nick + 1, line);
#endif
                        from_server = old_server;
                        continue;
                }
		if (*nick == '/') /* Command */
		{
			malloc_strcpy(&query_command, nick);
			malloc_strcat(&query_command, " ");
			malloc_strcat(&query_command, line);
			parse_command(query_command, 0, empty_string);
			new_free(&query_command);
			continue;
		}
		switch (send_text_flag)
		{
			case MSG_LIST:
				command = "NOTICE";
				break;
			case NOTICE_LIST:
				bitchsay("You cannot send a message from a NOTICE");
				new_free(&free_nick);
				return;
		}
		if (is_channel(nick))
		{
			int	current;

			current = is_current_channel(nick, curr_scr_win->server, 0);
			if (!command || strcmp(command, "NOTICE"))
			{
				command = "PRIVMSG";
				lastlog_level = set_lastlog_msg_level(LOG_PUBLIC);
				message_from(nick, LOG_PUBLIC);
				list_type = SEND_PUBLIC_LIST;
				the_thing = '>';
			}
			else
			{
				lastlog_level = set_lastlog_msg_level(LOG_NOTICE);
				message_from(nick, LOG_NOTICE);
				list_type = SEND_NOTICE_LIST;
				the_thing = '-';
			}
			if (do_hook(list_type, "%s %s", nick, line))
			{
				if (current)
					put_it("\002%c\002 %s", the_thing, line);
				else
					put_it("\002%c\002%s\002>\002 %s", the_thing, nick, line);
			}
			set_lastlog_msg_level(lastlog_level);
			if ((key = is_crypted(nick)) != 0)
			{
				char	*crypt_line;

				if ((crypt_line = crypt_msg(line, key, 1)))
					send_to_server("%s %s :%s", command, nick, crypt_line);
				new_free(&crypt_line);
				continue;
			}
			if (!in_on_who)
			{
				if (*nick_list)
				{
					strcat(nick_list, ",");
					strcat(nick_list, nick);
				}
				else
					strcpy(nick_list, nick);
			}
			do_final_send = 1;
		}
		else
		{
			if (!command || strcmp(command, "NOTICE"))
			{
				lastlog_level = set_lastlog_msg_level(LOG_MSG);
				command = "PRIVMSG";
				message_from(nick, LOG_MSG);
				list_type = SEND_MSG_LIST;
				the_thing = '*';
			}
			else
			{
				lastlog_level = set_lastlog_msg_level(LOG_NOTICE);
				message_from(nick, LOG_NOTICE);
				list_type = SEND_NOTICE_LIST;
				the_thing = '-';
			}
			comtemp[0] = the_thing;
			comtemp[1] = '\0';
			logmsg(1, comtemp, nick, line, NULL, 0);
			strcpy(last_sent_msg_body, line);
			if (forwardnick[0])
			    send_to_server("NOTICE %s :-> *%s* %s", 
				forwardnick, nick, line);
			if (window_display && do_hook(list_type, "%s %s", nick, line))
				put_it("-> %c%s%c %s", the_thing, nick, the_thing, line);
			if ((key = is_crypted(nick)) != NULL)
			{
				char	*crypt_line;

				if ((crypt_line = crypt_msg(line, key, 1)))
					send_to_server("%s %s :%s", command ? command : "PRIVMSG", nick, crypt_line);
				new_free(&crypt_line);
				continue;
			}
			set_lastlog_msg_level(lastlog_level);

			if (!in_on_who)
			{
				if (*nick_list)
				{
					strcat(nick_list, ",");
					strcat(nick_list, nick);
				}
				else
					strcpy(nick_list, nick);
			}

			if (get_int_var(WARN_OF_IGNORES_VAR) && (check_ignore(nick, NULL, IGNORE_MSGS) == IGNORED))
				bitchsay("Warning: You are ignoring private messages from %s", nick);

			malloc_strcpy(&sent_nick, nick);
			do_final_send = 1;
		}
	}

	malloc_strcpy(&sent_body, line);
	if (check_away && server_list[curr_scr_win->server].away && get_int_var(AUTO_UNMARK_AWAY_VAR))
	{
		check_away = 1;
		parse_command("AWAY", 0, empty_string);
	}
	if (do_final_send)
		send_to_server("%s %s :%s", command ? command : "PRIVMSG", nick_list, line);
	message_from(NULL, LOG_CRAP);
	new_free(&free_nick);
}

void
do_send_text(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*tmp;

	if (command)
		tmp = get_channel_by_refnum(0);
	else
		tmp = get_target_by_refnum(0);
	send_text(tmp, args, NULL);
}

/*
 * command_completion: builds lists of commands and aliases that match the
 * given command and displays them for the user's lookseeing 
 */
void
command_completion(unused, not_used)
	char	unused;
	char *	not_used;
{
	int	do_aliases;
	int	cmd_cnt,
		alias_cnt,
		i,
		c,
		len;
	char	**aliases = NULL;
	char	*line = NULL,
		*com,
		*cmdchars,
		*rest,
		firstcmdchar = '/';
	IrcCommand	*command;
	char	buffer[BIG_BUFFER_SIZE + 1];
	
	malloc_strcpy(&line, get_input());
	if ((com = next_arg(line, &rest)) != NULL)
	{
		if (!(cmdchars = get_string_var(CMDCHARS_VAR)))
			cmdchars = DEFAULT_CMDCHARS;
		if (index(cmdchars, *com))
		{
			firstcmdchar = *cmdchars;
			com++;
			if (*com && index(cmdchars, *com))
			{
				do_aliases = 0;
				alias_cnt = 0;
				com++;
			}
			else
				do_aliases = 1;
			upper(com);
			if (do_aliases)
				aliases = match_alias(com, &alias_cnt,
					COMMAND_ALIAS);
			if ((command = find_command(com, &cmd_cnt)) != NULL)
			{
				if (cmd_cnt < 0)
					cmd_cnt *= -1;
				/* special case for the empty string */

				if (*(command[0].name) == (char) 0)
				{
					command++;
					cmd_cnt = NUMBER_OF_COMMANDS;
				}
			}
			if ((alias_cnt == 1) && (cmd_cnt == 0))
			{
				sprintf(buffer, "%c%s %s", firstcmdchar, aliases[0], rest);
				set_input(buffer);
				new_free((char **)&(aliases[0]));
				new_free((char **)&aliases);
				update_input(UPDATE_ALL);
			}
			else if (((cmd_cnt == 1) && (alias_cnt == 0)) ||
			    ((cmd_cnt == 1) && (alias_cnt == 1) &&
			    (strcmp(aliases[0], command[0].name) == 0)))
			{
				sprintf(buffer, "%c%s%s %s", firstcmdchar,
					do_aliases ? "" : &firstcmdchar,
					command[0].name, rest);
				set_input(buffer);
				update_input(UPDATE_ALL);
			}
			else
			{
				*buffer = (char) 0;
				if (command)
				{
					bitchsay("Commands:");
					strmcpy(buffer, "\t", BIG_BUFFER_SIZE);
					c = 0;
					for (i = 0; i < cmd_cnt; i++)
					{
						strmcat(buffer, command[i].name,
							BIG_BUFFER_SIZE);
						for (len = strlen(command[i].name); len < 15; len++)
							strmcat(buffer, " ", BIG_BUFFER_SIZE);
						if (++c == 4)
						{
							say("%s", buffer);
							strmcpy(buffer, "\t", BIG_BUFFER_SIZE);
							c = 0;
						}
					}
					if (c)
						bitchsay("%s", buffer);
				}
				if (aliases)
				{
					bitchsay("Aliases:");
					strmcpy(buffer, "\t", BIG_BUFFER_SIZE);
					c = 0;
					for (i = 0; i < alias_cnt; i++)
					{
						strmcat(buffer, aliases[i], BIG_BUFFER_SIZE);
						for (len = strlen(aliases[i]); len < 15; len++)
							strmcat(buffer, " ", BIG_BUFFER_SIZE);
						if (++c == 4)
						{
							say("%s", buffer);
							strmcpy(buffer, "\t", BIG_BUFFER_SIZE);
							c = 0;
						}
						new_free(&(aliases[i]));
					}
					if (strlen(buffer) > 1)
						say("%s", buffer);
					new_free((char **)&aliases);
				}
				if (!*buffer)
					term_beep();
			}
		}
		else
			term_beep();
	}
	else
		term_beep();
	new_free(&line);
}

/* parse_line: This is the main parsing routine.  It should be called in
 * almost all circumstances over parse_command().
 *
 * parse_line breaks up the line into commands separated by unescaped
 * semicolons if we are in non interactive mode. Otherwise it tries to leave
 * the line untouched.
 *
 * Currently, a carriage return or newline breaks the line into multiple
 * commands too. This is expected to stop at some point when parse_command
 * will check for such things and escape them using the ^P convention.
 * We'll also try to check before we get to this stage and escape them before
 * they become a problem.
 *
 * Other than these two conventions the line is left basically untouched.
 */
/* Ideas on parsing: Why should the calling function be responsible
 *  for removing {} blocks?  Why cant this parser cope with and {}s
 *  that come up?
 */
#ifdef __STDC__
extern void	parse_line (char *name, char *org_line, char *args, int hist_flag, int append_flag)
#else
extern void
parse_line(name, org_line, args, hist_flag, append_flag)
	char	*name,
		*org_line,
		*args;
	int	hist_flag,
		append_flag;
#endif
{
	char	*line = NULL,
		*free_line,
		*stuff,
		*buffer = NULL,
		*s,
		*t;
	int	args_flag = 0;

	malloc_strcpy(&line, org_line);
	free_line = line;

	if (!*line)
		do_send_text(NULL, empty_string, empty_string);
	else
        if (args) do 
        {
                while (*line == '{') 
                {
                        if ((stuff = next_expr(&line, '{')) == NULL) 
			{
                                yell("Unmatched {");
                                new_free(&free_line);
                                return;
                        }
                        parse_line(name, stuff, args, hist_flag, append_flag);
			while (line && *line && ((*line == ';') || (isspace(*line))))
				*line++ = '\0';
		}

		if (!line || !*line)
			return;

		stuff = expand_alias(name, line, args, &args_flag, &line);
		if (!line && append_flag && !args_flag && args && *args)
		{
                        malloc_sprintf(&buffer, "%s %s",stuff, args);
			new_free(&stuff);
			stuff = buffer;
		};
		parse_command(stuff, hist_flag, args);
		if (!line) new_free(&free_line);
                new_free(&stuff);
	} while (line && *line);
        else
	{
		if (load_depth)
			parse_command(line, hist_flag, args);
		else
			for (;(s = line);)
			{
				if ((t = sindex(line, "\r\n")))
				{
					*t++ = '\0';
					line = t;
				}
				else
					line = NULL;
				parse_command(s, hist_flag, args);
			}
	}
	new_free(&free_line);
	return;
}

/*
 * parse_command: parses a line of input from the user.  If the first
 * character of the line is equal to irc_variable[CMDCHAR_VAR].value, the
 * line is used as an irc command and parsed appropriately.  If the first
 * character is anything else, the line is sent to the current channel or to
 * the current query user.  If hist_flag is true, commands will be added to
 * the command history as appropriate.  Otherwise, parsed commands will not
 * be added. 
 *
 * Parse_command() only parses a single command.  In general, you will want
 * to use parse_line() to execute things.Parse command recognized no quoted
 * characters or anything (beyond those specific for a given command being
 * executed). 
 */
int
parse_command(line, hist_flag, sub_args)
	char	*line;
	int	hist_flag;
	char	*sub_args;
{
static	unsigned int	 level = 0;
	unsigned int	display,
			old_display_var;
		char	*cmdchars,
			*com,
			*this_cmd = NULL;
		int	args_flag = 0,
			add_to_hist,
			cmdchar_used = 0;
		int	noisy = 1;
		
	if (!line || !*line)
		return 0;

	if (get_int_var(DEBUG_VAR) & DEBUG_COMMANDS)
		yell("Executing [%d] %s", level, line);
	level++;
	if (!(cmdchars = get_string_var(CMDCHARS_VAR)))
		cmdchars = DEFAULT_CMDCHARS;
	this_cmd = NULL;
	this_cmd = m_strdup(line);
	add_to_hist = 1;
	display = window_display;
	old_display_var = (unsigned) get_int_var(DISPLAY_VAR);
	for ( ;*line;line++)
	{
		if (*line == '^')
		{
			if (!noisy)
				break;
			noisy = 0;
		}
		else if (index(cmdchars, *line))
		{
			cmdchar_used++;
			if (cmdchar_used > 2)
				break;
		}
		else
			break;
	}
	if (!noisy)
		window_display = 0;
	com = line;
	/*
	 * always consider input a command unless we are in interactive mode
	 * and command_mode is off.   -lynx
	 */
	if (hist_flag && !cmdchar_used && !get_int_var(COMMAND_MODE_VAR))
	{
		do_send_text(NULL, line, empty_string);
		if (hist_flag && add_to_hist)
		{
			add_to_history(this_cmd);
			set_input(empty_string);
		}
		/* Special handling for ' and : */
	}
	else if (*com == '\'' && get_int_var(COMMAND_MODE_VAR))
	{
		do_send_text(NULL, line+1, empty_string);
		if (hist_flag && add_to_hist)
		{
			add_to_history(this_cmd);
			set_input(empty_string);
		}
	}
	else if (*com == '@')
	{
		/* This kludge fixes a memory leak */
		char	*tmp;

		tmp = parse_inline(line + 1, sub_args, &args_flag);
		if (tmp)
			new_free(&tmp);
		if (hist_flag && add_to_hist)
		{
			add_to_history(this_cmd);
			set_input(empty_string);
		}
	}
	else
	{
		char	*rest,
			*alias = NULL,
			*alias_name;
		int	cmd_cnt,
			alias_cnt = 0;
		IrcCommand	*command = NULL; /* = (IrcCommand *) 0 */

		if ((rest = (char *) index(com, ' ')) != NULL)
			*(rest++) = (char) 0;
		else
			rest = empty_string;
		upper(com);

		if (cmdchar_used < 2)
			alias = get_alias(COMMAND_ALIAS, com, &alias_cnt, &alias_name);

		if (alias && (alias_cnt == 0))
		{
			if (hist_flag && add_to_hist)
			{
				add_to_history(this_cmd);
				set_input(empty_string);
			}
			execute_alias(alias_name, alias, rest);
			new_free(&alias_name);
		}
		else
		{
			/* History */
			if (*com == '!')
			{
				if ((com = do_history(com + 1, rest)) != NULL)
				{
					if (level == 1)
					{
						set_input(com);
						update_input(UPDATE_ALL);
					}
					else
						parse_command(com, 0, sub_args);
					new_free(&com);
				}
				else
					set_input(empty_string);
			}
			else
			{
				if (hist_flag && add_to_hist)
				{
					add_to_history(this_cmd);
					set_input(empty_string);
				}
				command = find_command(com, &cmd_cnt);
				if ((command && (cmd_cnt < 0)) || ((alias_cnt == 0) && (cmd_cnt == 1)))
				{
					if (command->func)
						command->func(command->server_func, rest, sub_args);
					else
						bitchsay("%s: command disabled", command->name);
				}
				else if (alias && (alias_cnt == 1) && 
				    (cmd_cnt == 1) && 
				    (strcmp(alias_name, command[0].name) == 0))
					execute_alias(alias_name, alias, rest);
				else if ((alias_cnt + cmd_cnt) > 1)
					bitchsay("Ambiguous command: %s", com);
				else if (alias && (alias_cnt == 1))
					execute_alias(alias_name, alias, rest);
				else if (!my_stricmp(com, nickname))
					me(NULL, rest, empty_string);
				else if (!my_stricmp(com, "ENV"))
					add_env(rest);
				else
					bitchsay("Unknown command: %s", com);
			}
			if (alias)
				new_free(&alias_name);
		}
	}
	if (old_display_var != get_int_var(DISPLAY_VAR))
		window_display = get_int_var(DISPLAY_VAR);
	else
		window_display = display;
	new_free(&this_cmd);
	level--;
	return 0;
}

/*
 * load: the /LOAD command.  Reads the named file, parsing each line as
 * though it were typed in (passes each line to parse_command). 




	Right now, this is broken, as it doesnt handle the passing of
	the '-' flag, which is meant to force expansion of expandos
	with the arguments after the '-' flag.  I think its a lame
	feature, anyhow.  *sigh*.



 */
#ifdef __STDC__
extern void	load (char *command, char *args, char *subargs)
#else
extern void	load(command, args, subargs)
	char	*command,
		*args;
	char	*subargs;
#endif
{
	FILE	*fp;
	char	*filename,
		*expanded = NULL;
	int	flag = 0;
        int     paste_level = 0;
	char	*start,
		*current_row = NULL,
		buffer[BIG_BUFFER_SIZE + 1];
	int	no_semicolon = 1;
	char	*irc_path;
	int	display;
        int     ack = 0;

	no_hook_notify = 1;
	irc_path = get_string_var(LOAD_PATH_VAR);
	if (!irc_path)
	{
		bitchsay("LOAD_PATH has not been set");
		return;
	}

	if (load_depth == MAX_LOAD_DEPTH)
	{
		bitchsay("No more than %d levels of LOADs allowed", MAX_LOAD_DEPTH);
		return;
	}
	load_depth++;
	status_update(0);

	/* 
	 * We iterate over the whole list -- if we use the -args flag, the
	 * we will make a note to exit the loop at the bottom after we've
	 * gone through it once...
	 */
	while (args && *args && (filename = next_arg(args, &args)))
	{
		/* 
		   If we use the args flag, then we will get the next
		   filename (via continue) but at the bottom of the loop
		   we will exit the loop 
		 */
		if (my_strnicmp(filename, "-args", strlen(filename)) == 0)
		{
			flag = 1;
			continue;
		}
		else if ((expanded = expand_twiddle(filename)))
		{
			char *ptr;
/*			expanded = m_strdup(filename); */
			ptr = expanded;
			fp = uzfopen (&expanded, irc_path);
			if (!fp)
			{
				/* uzfopen emits an error if the file
				 * is not found, so we dont have to. */
				status_update(1);
				load_depth--;
				new_free(&expanded);
				return;
			}
			if (command && *command == 'W')
			{
				bitchsay ("%s", expanded);
				if (fp)
					fclose (fp);
				status_update(1);
				load_depth--;
				new_free(&expanded);
				return;
			}
/* Reformatted by jfn */
/* *_NOT_* attached, so dont "fix" it */
{
	int	in_comment 	= 0;
	int	comment_line 	= -1;
	int 	line 		= 1;
	int 	paste_line	= -1;

	display = window_display;
	window_display = 0;
	current_row = NULL;

	for (;;line++)
	{
	       if (fgets(buffer,BIG_BUFFER_SIZE / 2,fp))
	       {
			int     len;
			char    *ptr;

			for (start = buffer; isspace(*start); start++)
				;
			if (!*start || *start == '#')
				continue;

			len = strlen(start);
			/*
			 * this line from stargazer to allow \'s in scripts for continued
			 * lines <spz@specklec.mpifr-bonn.mpg.de>
			 */
			/* 
			   If we have \\ at the end of the line, that
			   should indicate that we DONT want the slash to 
			   escape the newline (hop)

			   We cant just do start[len-2] because we cant say
			   what will happen if len = 1... (a blank line)

			   SO.... 
			   If the line ends in a newline, and
			   If there are at least 2 characters in the line
				and the 2nd to the last one is a \ and,
			   If there are EITHER 2 characters on the line or
				the 3rd to the last character is NOT a \ and,
			   If the line isnt too big yet and,
			   If we can read more from the file,
			   THEN -- adjust the length of the string
			*/
			while ( (start[len-1] == '\n') && 
				(len >= 2 && start[len-2] == '\\') &&
				(len < 3 || start[len-3] != '\\') && 
				(len < BIG_BUFFER_SIZE / 2) && 
				(fgets(&(start[len-2]), BIG_BUFFER_SIZE / 2 - len, fp)))
			{
				len = strlen(start);
				line++;
			}

			if (start[len - 1] == '\n')
				start[--len] = '\0';

			while (start && *start)
			{
				char    *optr = start;

				/* Skip slashed brackets */
				while ((ptr = sindex(optr, "{};/")) && 
				      ptr != optr && ptr[-1] == '\\')
					optr = ptr+1;

				/* if no_semicolon is set, we will not attempt
				 * to parse this line, but will continue
				 * grabbing text
				 */
				if (no_semicolon)
					no_semicolon = 0;
				else if ((!ptr || (ptr != start || *ptr == '/')) && current_row)
				{
					if (!paste_level)
					{
						parse_line(NULL, current_row, flag ? args : NULL, 0, 0);
						new_free(&current_row);
					}
					else if (!in_comment)
						malloc_strcat(&current_row, ";");
				}

				if (ptr)
				{
					char    c = *ptr;

					*ptr = '\0';
					if (!in_comment)
						malloc_strcat(&current_row, start);
					*ptr = c;

					switch (c)
					{
		/* switch statement tabbed back */
case '/' :
{
	/* If we're in a comment, any slashes that arent preceeded by
	   a star is just ignored (cause its in a comment, after all >;) */
	if (in_comment)
	{
		/* ooops! cant do ptr[-1] if ptr == optr... doh! */
		if ((ptr > start) && (ptr[-1] == '*'))
		{
			in_comment = 0;
			comment_line = -1;
		}
		else
			break;
	}
	/* We're not in a comment... should we start one? */
	else
	{
		/* COMMENT_BREAKAGE_VAR */
		if ((ptr[1] == '*') && get_int_var(COMMENT_BREAKAGE_VAR) && (ptr == start))
			/* This hack (at the request of Kanan) makes it
			   so you can only have comments at the BEGINNING
			   of a line, and any midline comments are ignored.
			   This is required to run lame script packs that
			   do ascii art crap (ie, phoenix, textbox, etc) */
		{
			/* Yep. its the start of a comment. */
			in_comment = 1;
			comment_line = line;
		}
		else
		{
			/* Its NOT a comment. Tack it on the end */
			malloc_strcat(&current_row, "/");

			/* Is the / is at the EOL? */
			if (ptr[1] == '\0')
			{
				/* If we are NOT in a block alias, */
				if (!paste_level)
				{
					/* Send the line off to parse_line */
					parse_line(NULL, current_row, flag ? args : NULL, 0, 0);
					new_free(&current_row);
					ack = 0; /* no semicolon.. */
				}
				else
					/* Just add a semicolon and keep going */
					ack = 1; /* tack on a semicolon */
			}
		}


	}
	no_semicolon = 1 - ack;
	ack = 0;
	break;
}
case '{' :
{
	if (in_comment)
		break;

	/* If we are opening a brand new {} pair, remember the line */
	if (!paste_level)
		paste_line = line;
		
	paste_level++;
	if (ptr == start)
		malloc_strcat(&current_row, " {");
	else
		malloc_strcat(&current_row, "{");
	no_semicolon = 1;
	break;
}
case '}' :
{
	if (in_comment)
		break;
        if (!paste_level)
		yell("Unexpected } in %s, line %d", expanded, line);
	else 
	{
        	--paste_level;

		if (!paste_level)
			paste_line = -1;
		malloc_strcat(&current_row, "}"); /* } */
		no_semicolon = ptr[1]? 1: 0;
	}
	break;
}
case ';' :
{
	if (in_comment)
		break;
	if ((*(ptr+1) == '\0') && (!paste_level))
	{
		parse_line(NULL, current_row, flag ? args : NULL, 0, 0);
		new_free(&current_row);
	}
	else
		malloc_strcat(&current_row, ";");
	no_semicolon = 1;
	break;
}
	/* End of reformatting */
					}
					start = ptr+1;
				}
				else
				{
					if (!in_comment)
						malloc_strcat(&current_row, start);
					start = NULL;
				}
			}
		}
		else
			break;
	}
	if (in_comment)
		yell("File %s ended with an unterminated comment in line %d", expanded, comment_line);
	if (current_row)
	{
		if (paste_level)
			yell("Unexpected EOF in %s trying to match '{' at line %d",
					expanded, paste_line);
		else
			parse_line(NULL,current_row, flag ? args: NULL,0,0);
		new_free(&current_row);
	}
	new_free(&expanded);
	fclose(fp);
	if (get_int_var(DISPLAY_VAR))
	       window_display = display;
}
/* End of reformatting */
		}
		else
			bitchsay("Unknown user");
		/* 
		 * brute force -- if we are using -args, load ONLY one file
		 * then exit the while loop.  We could have done this
		 * by assigning args to NULL, but that would only waste
		 * cpu cycles by relooping...
		 */
		if (flag)
			break;
	}	/* end of the while loop that allows you to load
		   more then one file at a time.. */
	status_update(1);
	load_depth--;
/*	send_to_server("%s", "WAITFORNOTIFY");*/
}



/* The SENDLINE command.. */
static	void
sendlinecmd(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	int	server;
	int	display;

	server = from_server;
	display = window_display;
	window_display = 1;
	parse_line(NULL, args, get_int_var(INPUT_ALIASES_VAR) ?empty_string : NULL, 1, 0);
	update_input(UPDATE_ALL);
	window_display = display;
	from_server = server;
}

/*
 * irc_clear_screen: the CLEAR_SCREEN function for BIND.  Clears the screen and
 * starts it if it is held 
 */
/*ARGSUSED*/
void
irc_clear_screen(key, ptr)
	char	key;
	char	*ptr;
{
	hold_mode(NULL, OFF, 1);
	my_clear(NULL, empty_string, empty_string);
}

/*ARGSUSED*/
static	void
cd(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*arg,
		*expand;
	char buffer[BIG_BUFFER_SIZE + 1];

	if ((arg = next_arg(args, &args)) != NULL)
	{
		if ((expand = expand_twiddle(arg)) != NULL)
		{
			if (chdir(expand))
				bitchsay("CD: %s", sys_errlist[errno]);
			new_free(&expand);
		}
		else
			bitchsay("CD No such dir");
	}
	getcwd(buffer, BIG_BUFFER_SIZE+1);
	bitchsay("Current directory: %s", buffer);
}

static	void
exec_cmd(char *command, char *args, char *subargs)
{
	char	buffer[BIG_BUFFER_SIZE + 1];
	sprintf(buffer, "%s %s", command, args);
	execcmd(NULL, buffer, subargs);
}

static	void
describe(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*target;

	target = next_arg(args, &args);
	if (target && args && *args)
	{
		int	old;
		int	from_level;
		char	*message;

		message = args;
		send_ctcp(ctcp_type[CTCP_PRIVMSG], target, "ACTION", "%s", message);

		old = set_lastlog_msg_level(LOG_ACTION);
		from_level = message_from_level(LOG_ACTION);
		if (do_hook(SEND_ACTION_LIST, "%s %s", target, message))
			put_it("* -> %s: %s %s", target,
				get_server_nickname(from_server), message);
		set_lastlog_msg_level(old);
		message_from_level(from_level);

	}
	else
		bitchsay("DESCRIBE <target> <action description>");
}

/*
 * New 'me' command - now automatically appends period.
 * Necessary for new 'action' script.   -lynx'92
 * Hardly, removed this as it was generally considered offensive
 */
static	void
me(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	if (args && *args)
	{
		char	*target;

		if ((target = get_target_by_refnum(0)) != NULL)
		{
			int	old;
			int	from_level;
			char	*message;

			if (*target == '=' || !strncmp(target, get_string_var(CMDCHARS_VAR), 1))
			{
				if (!(target = get_channel_by_refnum(0)))
				{
					bitchsay("No target, neither channel nor query");
					return;
				}
			}
			message = args;
			send_ctcp(ctcp_type[CTCP_PRIVMSG], target, "ACTION", "%s", message);

			old = set_lastlog_msg_level(LOG_ACTION);
			from_level = message_from_level(LOG_ACTION);
			if (do_hook(SEND_ACTION_LIST, "%s %s", target, message))
			{
				if (strchr("&#", *target))
				put_it("* %s %s",
				    get_server_nickname(from_server), message);
				else
				put_it("* -> %s: %s %s",
				    target, get_server_nickname(from_server),
					message);
			}
			set_lastlog_msg_level(old);
			message_from_level(from_level);
		}
		else
			bitchsay("No target, neither channel nor query");
	}
	else
		bitchsay("ME <action description>");
}

static	void
mload(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*file;

	while ((file = next_arg(args, &args)) != NULL)
		load_menu(file);
}

static	void
mlist(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*menu;

	while ((menu = new_next_arg(args, &args)) != NULL)
		(void) ListMenu(menu);
}

/*
 * eval_inputlist:  Cute little wrapper that calls parse_line() when we
 * get an input prompt ..
 */

void
eval_inputlist(args, line)
	char	*args,
		*line;
{
	parse_line(NULL, args, line ? line : empty_string, 0, 0);
}

static	void
evalcmd(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	parse_line(NULL, args, subargs ? subargs : empty_string, 0, 0);
}

/*
 * inputcmd:  the INPUT command.   Takes a couple of arguements...
 * the first surrounded in double quotes, and the rest makes up
 * a normal ircII command.  The command is evalutated, with $*
 * being the line that you input.  Used add_wait_prompt() to prompt
 * the user...  -phone, jan 1993.
 */

static	void
inputcmd(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*prompt;

	if (!args || !*args)
		return;
	
	if (*args++ != '\"')
	{
		bitchsay("Need \" to begin prompt for INPUT");
		return;
	}

	prompt = args;
	if ((args = index(prompt, '"')) != NULL)
		*args++ = '\0';
	else
	{
		bitchsay("Missing \" in INPUT");
		return;
	}

	for (; *args == ' '; args++)
		;

	add_wait_prompt(prompt, eval_inputlist, args, WAIT_PROMPT_LINE);
}

/* pingcmd: ctcp ping, duh - phone, jan 1993. */
static	void
pingcmd(command, args, subargs)
	char    *command,
		*args,
		*subargs;
{
	struct  timeval         tp;
	char buffer[BIG_BUFFER_SIZE + 1];
	get_time(&tp);

	switch(get_int_var(PING_TYPE_VAR))
	{
		case 1:
			sprintf(buffer, "%s PING %ld %ld", args?args:"", (long)tp.tv_sec,(long)tp.tv_usec);
			break;
		case 2:
			sprintf(buffer, "%s ECHO %ld %ld", args?args:"", (long)tp.tv_sec,(long)tp.tv_usec);
			break;
		default:
			sprintf(buffer, "%s PING %ld", args?args:"", time(NULL));
	}
	ctcp(command, buffer, empty_string);
}

static	void
xtypecmd(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	char	*arg;

	if (args && (*args == '-' || *args == '/'))
	{
		char saved = *args;
		args++;
		if ((arg = next_arg(args, &args)) != NULL)
		{
			if (!my_strnicmp(arg, "L", 1))
			{
				for (; *args; args++)
					input_add_character(*args, empty_string);
			}
			else
				bitchsay ("Unknown flag -%s to XTYPE", arg);
			return;
		}
		input_add_character(saved, empty_string);
	}
	else
		type(command, args, empty_string);
	return;
}

static	void
beepcmd(command, args, subargs)
	char	*command,
		*args,
		*subargs;
{
	term_beep();
}

#ifdef __STDC__
extern void e_debug (char *command, char *args, char *subargs)
#else
extern void e_debug(command, args, subargs)
char *command, *args, *subargs;
#endif
{
	int x;
	char buffer[BIG_BUFFER_SIZE + 1];

	*buffer = 0;
	for (x = 0; x < FD_SETSIZE; x++)
	{
		if (FD_ISSET(x, &readables))
		{
			strcat(buffer, " ");
			strcat(buffer, ltoa(x));
		}
	}
	yell(buffer);
}
